/*
 * Copyright (c) 2005-2006 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * rtlx/rtlx.c: MIPS SDE example
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/fcntl.h>

int main(int argc, char **argv)
{
    int c, i = 0, fd[3];
    char buff[255];
    FILE *fp;

    printf("Hello World!\n");
    fd[0] = open("/dev/lx3", O_RDWR);
    fd[1] = open("/dev/lx4", O_RDWR);

    if (fd[0] < 0 || fd[1] < 0) {
	printf("unable to open /dev/lx? devices errno %d\n", errno);
	return (0);
    }

    while (1) {
	char tbuff[255];

	if ((i = read(0, buff, 255)) > 0) {
	    buff[i] = 0;
	    printf("<%s>\n", buff);
	}

	if ((i = read(fd[0], buff, 255)) > 0) {
	    buff[i] = 0;
	    sprintf(tbuff, "<%s>", buff);
	    write(fd[0], tbuff, strlen(tbuff));
	}

	if ((i = read(fd[1], buff, 255)) > 0) {
	    buff[i] = 0;
	    sprintf(tbuff, "<%s>", buff);
	    write(fd[1], tbuff, strlen(tbuff));
	}
    }


    return 0;
}
