/*
 * Copyright (c) 1998-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * NITRO/sbd.h: board-specific header for LSI Nitro (CW401x) eval board
 */


/* 40MHz bus clock? */
#define HZ	40000000

/* CPU count register runs at pipeline frequency */
#define _SBD_CLK_MULT	1
#define _SBD_CLK_DIV	1

/* Device base */
#define RTC_BASE	0x11000000
#define EXP_BASE	0x12000000
#define LED_BASE	0x13000000
#define RTC_ACK_BASE	0x1a000000
#define DUART_BASE	0x1e000000
#define SONIC_BASE	0x1c000000

/* Interrupt mapping */
#define INTR_DUART	2	/* duart on INT0 */
#define INTR_SONIC	3	/* sonic on INT1 */
#define INTR_RTC_1024HZ	3	/* RTC oscillator on INT2 */
#define INTR_RTC_INTA	4	/* RTC INTA on INT3 */
#define INTR_RTC_INTB	5	/* RTC INTB on INT4 */

/* S2681 uart defs */
#define S2681REGSZ	4
