#
# SKEL/sbd.mk: SKEL board
#

# Where to find the source code, for multiple boards sharing a common source 
# directory this would be look something like:
#SBDDIRS	=../SKEL:../skel_common
SBDDIRS		=../SKEL

# Add any compile flags specific to this board; used when compiling the
# kit code *and* the example programs.
SBDFLAGS  	=-DSKEL

# Add any compile flags specific to this board; used only when compiling 
# the kit code, e.g.
#KITFLAGS	=-DSIMULATESSTEP -DDBGVA

# Define the base cpu type (e.g. 4kc, 24kc, etc)
CPU	  	=4kc

# Define the cpu variant (e.g. r4600, lr33020, rm5230, etc), if any, e.g.
#CPUVARIANT	=lr33020

# Set the Instruction Set Architecture 
#ISA		=-mips32
#ISA		=-mips32r2
#ISA		=-mips64

# Set the CPU endianness (-EB/-EL)
ENDIAN	  	=-EB

# If you have need special cache code for this CPU variant, then define 
# a list of the caches here.  
# The default is $(CPU)
# Existing options include:
#  r3k		  = R3000 family cache handling
#  r4k		  = R4000 family cache handling
#  r5k		  = R5000 family cache handling
#  r54	  	  = NEC Vr5400/5500 cache handling
#  rm7k		  = QED RM7000 cache handling
#  cw		  = LSI coreware family cache handling
#  lr30		  = LR330x0 family cache handling
#  m32		  = MIPS32/64 cache handling
#  no		  = dummy cache handling for CPUs w/o cache
#CACHES		=m32

# If this CPU variant doesn't have a TLB, uncomment the following line.
# The default is $(CPU).
#TLB		=no

# Set FPU to one of:
#  yes	 = always has an fpu (e.g. r4000)
#  no	 = never has an fpu (e.g. r3051)
#  single= single-precision fpu (e.g. r4640, r4650)
#  maybe = could be configured with an fpu
FPU		=no

# Define NVENV to be the name of the module which implements the
# non-volatile environment store.  Default is a dummy module which
# doesn't retain data persistently.
#NVENV		=nvenv
#NVENV		=flashenv

# Define the list of source modules which are in this directory
SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx sbdmem.c \
		 sbdtime.c sbdclock.c sbdfreq.c \
		 sbdflashenv.c sbdfrom.c flashrom.c \
		 sbdpanel.c sbdpci.c

# List those object modules required for ROM startup support 
# (comment out if you don't need ROM startup, for example if
# you always run in RAM under control of another PROM monitor)
SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

# List those object modules required for both ROM and RAM board libraries. 
# This will probably include those in SBDLOW, except for sbdreset.o.
SBDOBJ		=sbdser.o sbdmisc.o sbdmem.o \
		 sbdtime.o sbdclock.o sbdfreq.o \
		 sbdflashenv.o sbdfrom.o flashrom.o \
		 sbdpanel.o sbdpci.o

# Define the PROM monitor on this board (if any), currently this must be
# one of:
#  bare	  = Bare board (no monitor)
#  pmon	  = PMON (LSI / Algorithmics / NEC / Cogent etc)
#  idtsim = IDT/sim
#  yamon  = YAMON
#  mdimon = Bare board or simulator with MDI (e.g. MIPSsim or EJTAG)
MONITOR		=bare

# Uncomment the following definition if you want to include the generic PCI 
# bus support code in ../pci.  You'll need to define the board-specific
# PCI code in a local file, e.g. see sbdpci.c.
#PCI		=yes

# List the optional board features to be available via POSIX file system:
# 	flashdev:	/dev/flash interface (needs sbdfrom.c)
# 	paneldev:	/dev/panel interface (needs sbdpanel.c)
SBDFEATURES	=flashdev paneldev

# Uncomment the following definition if you have implemented board-support
# for the RTPX real-time kernel.
#RTPX		=yes

# Define the lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000

# Define the ROM base address (cached and uncached) and size.
# Only necessary if it is not the standard 0x9fc00000/0xbfc00000
#ROM_C		=9fc00000
#ROM_U		=bfc00000
#ROM_SZ		=400000

# Define the RAM base address, cached and uncached.
# Only necessary if it is not the standard 0x80000280/0xa0000280
# (the 280 is to leave space for the exception vectors) 
#RAM_C		=80000280
#RAM_U		=a0000280
