#ident "kit/SKEL/sbdflashenv.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 2000-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * SKEL/sbdflashenv.c: board-specific environment in Flash
 *
 * Required only if you are using ../share/flashenv.c to store
 * the non-volatile environment in Flash. Otherwise use 
 * sbdnvram.c.
 */


#include <stddef.h>
#include <mips/cpu.h>
#include "kit_impl.h"

#include "flashdev.h"
#include "sbd.h"

flashcookie_t
_sbd_flashenv_open (void)
{
    /* XXX board specific address - wired-down flash prom */
    return flash_open (FLASH_BASE);
}


#if !defined(ITBASE)
/*
 * Return non-zero if the environment should be reset to default state,
 * for example if a board link or switch is set, or (in desparation)
 * if the UART's CTS & RTS are looped together (see ../p5064/sbdflashenv.c).
 *
 * This is important if the user accidentally sets a critical environment
 * variable incorrectly, which prevents them from talking to the PROM
 * monitor and resetting it.
 *
 * Omit if ITROM is present, because it will have already
 * handled this, and may have placed other status values in
 * the environment which we must read.
 */

int
_sbd_env_force_reset (void)
{
    return 0;
}
#endif
