/*
 * Copyright (c) 1999-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * SKEL/sbdfrom.h: onboard FROM support for skeleton board
 */


/* Define range of possible parts on this board */
/* XXX being precise gives smaller and faster flash code */
#define FROM_FAMILY_ATMEL	1
#define FROM_FAMILY_INTEL	1
#define FROM_FAMILY_AMD		1

/* Fixed device geometry on this board */
#define FROM_WIDTH		1	/* dev width = byte */
#define FROM_NCOLS		1	/* 1 device in parallel */
#define FROM_GROUP		1	/* 1 device per access */

/* "Variable" device geometry */
/* XXX if any are fixed, not variable, then define them here */
/*#define FROM_SECSIZE(fcp)*/		/* sector size in bytes */
/*#define FROM_NBANKS(fcp)*/		/* # sequential banks of flash */
/*#define FROM_DEVSIZE(fcp)*/		/* device size in bytes */
/*#define FROM_DEVSIZE_LOG2(fcp)*/	/* log2(device size) */

/* Define to enable debug messages */
/*#define FROM_DEBUG*/

/* Define if code (in particular flash programming code) 
   will never executed be from the flash rom. */
/*#define FROM_NEVER_SELF_PROGRAM*/

/* Define as 0 if device cannot always be accessed as a sequential
   array of bytes */
/*#define FROM_MAPPABLE	1*/

/* Define conditions when device cannot be read sequentially */
/* #define FROM_READ_CONTIGUOUS(flags) 1 */

/* If required, any special twiddling of the read or programming 
   address (as line or column byte offset) can be done here. */

/* Line address munging when programming */
/* #define frompline(x,flags) (x) */

/* Reverse the action when reading */
/* #define fromrline(x,flags) (x) */

/* Column index munging */
/*#define fromrcol(x,flags) (x) */
/*#define frompcol(x,flags) (x) */

/* Enable/disable WR */
/*#define fromwrenable(fcp) */
/*#define fromwrdisable(fcp) */

/* Enable/Disable Vpp */
/*#define fromvppenable(fcp)*/
/*#define fromvppdisable(fcp)*/

/* Return external h/w protect status for offset */
/*#define fromprotected(fcp, offs)*/
