#
# idt33x/sbd.mk: IDT 79S33x board with RC32333x generic board support
#
# NOTE: You must explicitly enable the on-chip timer interrupts 
# on this board!  See the board manual.
#

SBDDIRS		=../idt33x
SBDFLAGS  	=-DIDT33X
KITFLAGS  	=-DINET

CPU	  	=r4k
CACHES		=rc32
CP0	  	=r4k
WPOINTS		=r4650
FPU		=no
CPUVARIANT	=rc3236x
ISA		=-mips32
#ENDIAN		=-EB

MONITOR		=idtsim

NVENV		=nvenv

SBDSRC		=sbdfreq.c sbdclock.c \
		 sbdfrom.c sbdbfrom.c sbdwfrom.c \
		 sbdpci.c sbdpanel.c \
		 sbdnvram.c sbdmem.c \
		 sbdreset.sx sbdmisc.sx sbdser.sx

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbdfreq.o sbdclock.o \
		 sbdser.o sbdnvram.o sbdmem.o sbdmisc.o \
		 sbdpci.o sbdpanel.o \
		 sbdfrom.o sbdbfrom.o sbdwfrom.o \

# MIPS RTPX support
RTPX		=yes
SBDRTPXCSRC	=sbdrtpx.c rtpx_ns16550.c
SBDRTPXSSRC	=

# AlgNET support (see sde/net/net.mk)
SBDNET  	=INET			# IPv4 only
SBDNETDRV	=if_de.o		# DEC ether chip driver
SBDNETDRV      +=if_le_pci.o am7990.o  	# AMD LANCE chip driver

# Support the /dev/flash and /dev/panel interface
SBDFEATURES	=flashdev paneldev

PCI		=yes

# define base address for downloadable programs (cached & uncached)
DLBASE_C	=80900000
DLBASE_U	=a0900000
