#
# malta/sbd.mk: MIPS Technologies Malta board (generic)
#

SBDDIRS		=../malta
SBDFLAGS  	=-DMALTA

# Enable MIPS16 support in kit code
KITFLAGS	+=-D__maybe_mips16

#CPU	  	=??
#CPUVARIANT	=??
#ISA		=??
#FPU		=??
#ENDIAN	  	=??

PCI		=yes

SBDSRC		=sbdser.sx sbdmisc.sx sbdfreq.c sbdrtc.c sbdtod.c sbdfrom.c \
		 sbdsysctrl.c sbdpci.c sbdpci-gal.c sbdpci-bon.c sbdpci-msc.c

SBDOBJ		=sbdser.o sbdmisc.o sbdfreq.o sbdrtc.o sbdtod.o \
		 sbdfrom.o flashrom.o r4kclock.o \
		 sbdsysctrl.o sbdpci-all.o

SBDDEPOBJS	=sbdpci.o sbdpci-gal.o sbdpci-bon.o sbdpci-msc.o

#ifeq (,$(PROG))
ifdef FULLSDE
sbdpci-all.o:	 sbdpci.o sbdpci-gal.o sbdpci-bon.o sbdpci-msc.o
	$(CC) $(LDFLAGS) -Wl,-r -nostartfiles -nostdlib -o $@ $^
endif
#endif

# No board-reset support yet
#SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

# Handle YAMON environment
NVENV		=sbdenv

# MIPS RTPX support
RTPX		=yes
SBDRTPXCSRC	=sbdrtpx.c rtpx_ns16550.c
SBDRTPXSSRC	=

# AlgNET support (see sde/net/net.mk)
SBDNET  	=INET			# IPv4 only

# Onboard AMD PCInet/LANCE ethernet driver
#SBDNETDRV	=if_le_pci.o am7990.o

# Have Flash support
SBDFEATURES	=flashdev

MONITOR		=yamon

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80100000
DLBASE_U	=a0100000

# Use MIPS flash download format for ROM builds
ROMDLFMT	=fl
