#
# malta/sbdmtsp.mk: MIPS Technologies Malta board
# SP variant of AP/SP model
#

# include $(KITDIR)/malta/sbd.mk

SBDDIRS		=../malta
SBDFLAGS  	=-DMALTA

MONITOR		=mtspmon
BAREMON		=mtspmon

# These will change for different simulated architectures
CPU	  	=34k
FPU		=no
ISA		=-mips32r2
ENDIAN	  	=-EB

# We don't want the SP playing with too many things.
PCI		=no
TLB		=no

# Enable MIPS16 support in kit code
KITFLAGS	=-D__maybe_mips16

# Override and use MTSPMON instead of YAMON
KITFLAGS	+=-DMTSPMON

# Can't determine memory size of our region when loaded by Linux, so set 
# fixed size stack and heap  here (stack=64K heap=1M)
KITFLAGS	+=-DDFLT_STACK_SIZE=65536 -DDFLT_HEAP_SIZE=1048576

SBDSRC		=sbdser.sx sbdmisc.sx
SBDOBJ		=sbdser.o sbdmisc.o r4kclock.o 
SBDLOW		=

# We don't support real serial port access, only via the mtsp monitor,
# so never build a "standalone" version of a program.
SBDNOSER	=true

# By default build relocatable applications
ALL		?=rel

# No conversion of ELF executable file to download format
DLFMT		=none
