.ident "kit/malta/serswitch.s: Copyright (c) MIPS Technologies, Inc. All rights reserved."
	
/*
 * Copyright (c) 2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * malta/serswitch.s: low level serial i/o switch for malta board
 */

#include "sbd.h"
	
#include <mips/asm.h>
#include <mips/regdef.h>
#include <mips/cpu.h>
#include "sbdser.h"


/* this is extremely naff... */
	
#ifdef UART1_BASE
#define NUARTSWT 3
#else
#define NUARTSWT 2
#endif

#ifndef DEFSPEED
#define DEFSPEED	9600	/* default console speed */
#endif
	
#ifndef DBGSPEED
#define DBGSPEED	9600	/* default debug speed */
#endif
	
	.rdata
EXPORTS(_sbdsertab, SS_SIZE * NUARTSWT)
	.word	0, swtreset, swtinit, swtparams, swtrxpoll, swttxrdy, swttx
#ifdef UART1_BASE	
	.word	SS_SIZE, swtreset, swtinit, swtparams, swtrxpoll, swttxrdy, swttx
#endif
	

/* number of ports */
EXPORTS(_sbdnser, 4)
	.word	NUARTSWT

/* remote debugging port number */
EXPORTS(_sbddbgport, 4)
	.word	NUARTSWT-1

/* default initial port speeds */
EXPORTS(_sbdspeed, NUARTSWT*4)
	.word	DEFSPEED
#if NUART == 2
	.word	DEFSPEED
#endif	


#define SWITCH(reloc,function) \
	addu	a0,reloc ; \
	and	a0,~3 ; \
	lw	v0,function(a0) ; \
	lw	a0,0(a0) ; \
	j	v0
	

/*
 * reset (chan, reloc)
 *
 * Once only device reset at power-on
 */
SLEAF(swtreset)
	SWITCH(a1,SS_RESET)
SEND(swtreset)


/*
 * init (chan, reloc)
 *
 * Per channel (re)initialisation.
 */
SLEAF(swtinit)
	SWITCH(a1,SS_INIT)
SEND(swtinit)


/*
 * params (chan, speed, reloc)
 *
 * program new speed, return 0 on success
 */
SLEAF(swtparams)
	SWITCH(a2,SS_PARAMS)
SEND(swtparams)


/*
 * rxpoll (chan, canblock, reloc) 
 *
 * poll for received character, return zero if none available
 */
SLEAF(swtrxpoll)
	SWITCH(a2,SS_RXPOLL)
SEND(swtrxpoll)


/* 
 * txrdy (chan, reloc) 
 *
 * return non-zero if ready to transmit
 */
SLEAF(swttxrdy)
	SWITCH(a1,SS_TXRDY)
SEND(swttxrdy)


/* 
 * tx (chan, data, reloc) 
 *
 * transmit data
 */
SLEAF(swttx)
	SWITCH(a2,SS_TX)
SEND(swttx)
