/*
 * Copyright (c) 2002-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * MIPS SDE kit MIPS MDI interface definitions
 */


#ifndef __ASSEMBLER__
extern int	_mdi_open (const char *, int, int);
extern int	_mdi_close (int);
extern int	_mdi_read (int, void *, int);
extern int	_mdi_write (int, const void *, int);
extern long	_mdi_lseek32 (int, long, int);
extern int	_mdi_getchar (int /*chan*/);
extern int	_mdi_putchar (int /*chan*/, int /*c*/);
struct timeval;
extern int	_mdi_gettime (struct timeval *);
extern int	_mdi_exit (int);
extern int	_mdi_isatty (int);
extern int	_mdi_syscall ();
extern int	_mdi_profil (int);
extern int	_mdi_sighook (int, void *);
#endif

#define _MDI_SYSCALL_OPEN	0
#define _MDI_SYSCALL_CLOSE	1
#define _MDI_SYSCALL_READ	2
#define _MDI_SYSCALL_WRITE	3
#define _MDI_SYSCALL_GETCHAR	4
#define _MDI_SYSCALL_PUTCHAR	5
#define _MDI_SYSCALL_LSEEK32	6
#define _MDI_SYSCALL_GETTIME	7
#define _MDI_SYSCALL_EXIT	8
#define _MDI_SYSCALL_MOVED	9
#define _MDI_SYSCALL_GETARGS	10
#define _MDI_SYSCALL_ISATTY	11
#define _MDI_SYSCALL_PROFIL	12
#define _MDI_SYSCALL_SIGHOOK	13
