#
# mipssim/sbd.mk: MIPSsim generic "board" configuration
#

SBDDIRS		=../mipssim
SBDFLAGS  	=-DMIPSSIM -D__SIM

# Enable MIPS16 support in kit code; disable h/w timer profiling
KITFLAGS	+=-D__maybe_mips16 -D_SDE_EXT_PROFIL

# Can't determine memory size when loaded into RAM by MDI, so set 
# fixed size stack and heap for RAM code here (stack=256K heap=32M)
# Note: assumes MIPSsim has simple, flat memory map configured up 
# to around 64M (0x4000000)
KITFLAGS	+=-DDFLT_STACK_SIZE=0x40000 -DDFLT_HEAP_SIZE=0x2000000

# These three will change for different simulated architectures
CPU	  	=4kc
ISA		=-mips32
ENDIAN	  	=-EB
FPU		=no

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx
SBDOBJ		=sbdser.o sbdmisc.o r4kclock.o
SBDLOW		=sbdreset.o sbdser.o sbdmisc.o 

# We don't support real serial port access under MIPSsim, only via the
# mtsp monitor, so never build a "standalone" version of a program.
SBDNOSER	=true

MONITOR		=mdimon
BAREMON		=mdimon

# Prefer to copy ROM code to RAM for better performance.
# But disable for now, since it makes debugging more confusing.
#SBDLAYOUT	=romcopy

# Convert ROM image to relocated ELF format for download by GDB
ROMDLFMT	=relf

# MIPSsim initialises enough of the virtual CPU that we can run code
# directly from simulated RAM without having to initialise the caches
# and TLB - as if it had been initialised by a PROM monitor. So build
# "ram" versions of programs linked to run just above the exception
# vectors.
DLBASE_C	=80001000
DLBASE_U	=a0001000
DLFMT		=none
