#
# mipssim/sbdmtsp.mk: MIPSsim "board" configuration 
# SP variant of AP/SP model
#

SBDDIRS		=../mipssim
SBDFLAGS  	=-DMIPSSIM -D__SIM

MONITOR		=mtspmon
BAREMON		=mtspmon

# These will change for different simulated architectures
CPU	  	=34k
FPU		=no
ISA		=-mips32r2
ENDIAN	  	=-EB

# We don't want the SP playing with too many things.
PCI		=no
TLB		=no

# Enable MIPS16 support in kit code; disable h/w timer profiling
KITFLAGS	=-D__maybe_mips16 -D_SDE_EXT_PROFIL

# Override and use MTSPMON instead of MDIMON
KITFLAGS	+=-DMTSPMON

# Can't determine memory size of our region when loaded by Linux, so set 
# fixed size stack and heap here (stack=64K heap=1M)
KITFLAGS	+=-DDFLT_STACK_SIZE=65536 -DDFLT_HEAP_SIZE=1048576

SBDSRC		=sbdser.sx sbdmiscsp.sx
SBDOBJ		=sbdser.o sbdmiscsp.o r4kclock.o
SBDLOW		=

# By default build relocatable applications
ALL		?=rel

# No conversion of ELF executable file to download format
DLFMT		=none

