/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * p4032/fsimm.h: FLASH SIMM support for P4032 board
 */


#define FSIMM_READARRAY		0x00ff00ff
#define FSIMM_ERASECHIP		0x00a700a7
#define FSIMM_ERASESECTOR	0x00200020
#define FSIMM_ERASECONFIRM	0x00d000d0
#define FSIMM_WRITE		0x00400040

#define FSIMM_WSMS		0x00800080
#define FSIMM_ESS		0x00400040
#define FSIMM_ES		0x00200020
#define FSIMM_DWS		0x00100010
#define FSIMM_VPPS		0x00080008


#define FSIMMSIZE		0x00800000	/* 8Mb total size */
#define FSIMMSECSIZE		0x00040000	/* 256Kb eff sector size */
#define FSIMMMAXSECSIZE		FSIMMSECSIZE
#define FSIMMMAXSECTORS		(FSIMMSIZE/FSIMMSECSIZE)

/* Flash SIMM is word-wide */
typedef unsigned int fsimm_t;

/* Device-specific open function */
struct flashcookie;
const struct flashcookie *	_sbd_fsimmopen (paddr_t);
