#
# p4032/sbd.mk: Algorithmics P4032 (generic)
#
# Use -mips3 so as to support 64-bit exception handling and all
# 32 floating-point registers, but select -mgp32 (32-bit integer
# registers) to reduce stack overhead and prologue/epilogue time.
#

SBDDIRS		=../p4032
SBDFLAGS  	=-DP4032 -DINET
KITFLAGS	=-DALGPMON
CPU	  	=r4k
ISA		=-mips3 -mgp32
#FPU		=??
#CPUVARIANT	=??
#ENDIAN	  	=??
PCI		=yes

DBGSIG		=sbddbg

NVENV		=nvenv

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx \
		 sbdpanel.c sbdtod.c \
		 sbdrtc.c sbdfreq.c sbdpio.c sbd.c sbdicu.c \
		 sbdeeprom.c sbdflash.c sbdfrom.c sbdfsimm.c \
		 pci_machdep.c

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbdser.o sbdmisc.o r4kclock.o sbdpanel.o \
		 sbdtod.o sbdrtc.o sbdfreq.o sbdpio.o sbd.o sbdicu.o \
		 sbdeeprom.o sbdflash.o sbdfrom.o sbdfsimm.o \
		 pci_machdep.o

# MIPS RTPX support
RTPX		=yes
SBDRTPXCSRC	=sbdrtpx.c rtpx_ns16550.c
SBDRTPXSSRC	=

# AlgNET support (see sde/net/net.mk)
SBDNET  	=INET			# IPv4 only
SBDNETDRV	=if_de.o		# DEC ether chip driver
		#dc.o dcphy.o 		# Alternative DEC driver?
		#if_le_pci.o am7990.o  	# AMD LANCE chip driver?
		#mii.o mii_physsubr.o 	# MII layer?

# Support the /dev/flash and /dev/panel interface
SBDFEATURES	=flashdev paneldev

MONITOR		=pmon

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000
