/*
 * Copyright (c) 1999-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * p4032/sbdfsimm.h: HP Flash SIMM support for P4032
 */


/* Only Intel parts on Flash SIMM */
#define FROM_FAMILY_INTEL	1

/* Fixed device geometry on this board */
#define FROM_WIDTH		2	/* dev width = word */
#define FROM_NCOLS		2	/* 2 device columns */
#define FROM_GROUP		2	/* 2 in parallel */
#define FROM_NBANKS(fcp)	2	/* 2 banks */

/* "Variable" device geometry */
/*#define FROM_DEVSIZE(fcp)*/
/*#define FROM_DEVSIZE_LOG2(fcp)*/

/* Note: always program/erase in 2 sector chunks, so multiply 
   physical sector size by 2 */
#define FROM_SECGROUP		2
#define FROM_SECSIZE(fcp)	0x20000


/* Define to enable debug messages */
/*#define FROM_DEBUG*/

/* Define if code (in particular flash programming code) 
   will never executed be from the flash rom. */
/*#define FROM_NEVER_SELF_PROGRAM*/

/* Define as zero if device cannot be mapped as normal memory */
#define FROM_MAPPABLE	1

/* Device-specific manipulation to line byte offset */
/*#define fromrline(offs,flags)*/
#define frompline(offs,flags) \
({ \
   unsigned int _offs = (offs); \
   (((flags) & _FLASHDEV_SECTOR) && (_offs & 0x20000)) \
   ? _offs ^ 0x20800 \
   : _offs; \
})

/* Device-specific column number to byte offset conversion */
/*#define frompcol(col,flags)*/ 
/*#define fromrcol(col,flags)*/
