#ident "kit/p4032/sbdintr.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 2000-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * p4032/sbdintr.c: experimental interrupt handling
 * XXX experimental stuff, do not use XXX 
 */


#if 0
/* 
 * Poll all interrupt interrupts, return complete set.
 * Called at ipl1 
 */
void
_sbd_intrpending (intrset_t *pend)
{
    volatile p4032icu *icu = PA_TO_KVA1 (ICU_BASE);
    unsigned int irr;
    irr = (mips_getcr() & CR_IMASK);
    irr |= (icu->irr.dev & 0xff);
    irr |= (icu->irr.pci & 0xf0) << 16;
    *pend = irr;
}

/*
 * Enable ipl0 interupts which have been blocked, in particular
 * when interrupt handler first installed.
 * Called at >= ipl1.
 */
void 
_sbd_intrenable (int intr)
{
    unsigned int irr = intrToIrr[intr];

    mips_atomic_bis (&_sbd_ipl0_sr, irr);
    if (irr & 0xff00) {
	/* now enabled at ipl0, so disable at ipl1 */
	mips_atomic_bic (&_sbd_ipl1_sr, irr);
    }
    else {
	volatile p4032icu *icu = PA_TO_KVA1 (ICU_BASE);
	if (irr & 0xff) {
	    icu->ctrl.mask = _sbd_ipl0_sr & 0xff;
	    mips_wbflush ();
	}
	else if (irr & 0xf00000) {
	    icu->ctrl.pcimask = ((_sbd_ipl0_sr >> 16) & 0xf0) | ICU_PCI_FDCDMA;
	    mips_wbflush ();
	}
    }
}


/* 
 * Manipulate enable state of groups of ipl0 interrupts.
 * Called at ipl1.
 */
void 
_sbd_intrprocmask (int how, const intrset_t *new, intrset_t *old)
{
    unsigned int om;
    
    /* block all interrupts */
    mips_setsr (_sbd_iplhi_sr);

    om = _sbd_ipl0_sr;

    if (new) {
	unsigned int nm = *new;
	unsigned int delta;

	switch (how) {
	case INTR_SETMASK:
	    break;
	case INTR_DISABLE:
	    nm = om &~ nm;
	    break;
	case INTR_ENABLE:
	    nm = om | nm;
	    break;
	default:
	    return;
	}

	_sbd_ipl0_sr = nm;

	/* update h/w masks if necessary */
	delta = (nm ^ om);
	if (delta & ~0xff00) {
	    volatile p4032icu *icu = PA_TO_KVA1 (ICU_BASE);
	    if (delta & 0xff) {
		icu->ctrl.mask = nm & 0xff;
		mips_wbflush ();
	    }
	    if (delta & 0xf00000) {
		icu->ctrl.pcimask = ((nm >> 16) & 0xf0) | ICU_PCI_FDCDMA;
		mips_wbflush ();
	    }
	}
    }

    /* return to ipl1 (scheduler priority) */
    mips_setsr (_sbd_ipl1_sr);

    if (old)
      *old = om;
}
#endif
