/*
 * Copyright (c) 1998-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * gpio.h: National Semiconductor PC97307 Multi I/O PIO
 */


/*
 * PIO register offsets from PIO base
 */
#define GPIO1_DATA	0x00
#define GPIO1_DIR	0x01
#define GPIO1_OTYPE	0x02
#define GPIO1_PULLUP	0x03
#define GPIO2_DATA	0x04
#define GPIO2_DIR	0x05
#define GPIO2_OTYPE	0x06
#define GPIO2_PULLUP	0x07

#ifndef __ASSEMBLER__
/* safe programmatic interface to pio */
void		_gpioa_dir (unsigned int);
unsigned int    _gpioa_get (void);
unsigned int    _gpioa_set (unsigned int);
unsigned int    _gpioa_bis (unsigned int);
unsigned int    _gpioa_bic (unsigned int);

void		_gpiob_dir (unsigned int);
unsigned int    _gpiob_get (void);
unsigned int    _gpiob_set (unsigned int);
unsigned int    _gpiob_bis (unsigned int);
unsigned int    _gpiob_bic (unsigned int);
#endif

