#
# p5064/sbd.mk: Algorithmics P5064 (generic)
#
# Use -mips3 so as to support 64-bit exception handling and all
# 32 floating-point registers, but select -mgp32 (32-bit integer
# registers) to reduce stack overhead and prologue/epilogue time.
#

SBDDIRS		=../p5064
SBDFLAGS  	=-DP5064 -DINET
KITFLAGS	=-DALGPMON
CPU	  	=r5k
ISA		=-mips4 -mgp32
PCI		=yes
#FPU		=??
#CPUVARIANT	=??
#ENDIAN	  	=??

#RTPX		=yes

#DBGSIG		=sbddbg

NVENV		=flashenv

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx \
		 sbd.c sbdapc.c sbddimm.c sbdpanel.c sbdtod.c sbdrtc.c \
		 sbdfreq.c sbdfrom.c sbdflashenv.c flashrom.c \
		 sbdpio.c sbdgpio.c sbdzpio.c pci_machdep.c

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbd.o sbdser.o sbdmisc.o sbdpanel.o \
		 sbdtod.o sbddimm.o sbdrtc.o sbdfreq.o \
		 sbdapc.o sbdpio.o sbdgpio.o sbdzpio.o \
		 sbdfrom.o sbdflashenv.o flashrom.o pci_machdep.o \
		 r4kclock.o

# Support the /dev/flash and /dev/panel interface
SBDFEATURES	=flashdev paneldev

MONITOR		=pmon

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000
