#ident "kit/p5064/sbdgpio.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1998-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * P5064/sbdgpio.c: low-level interface to P5064 PC97307 PIO device
 */


#include <stddef.h>
#include <mips/cpu.h>
#include "sbd.h"
#include "gpio.h"


void
_gpioa_dir (unsigned int outputs)
{
    outb (GPIO_PORT + GPIO1_DIR, outputs);
}

unsigned int 
_gpioa_get (void)
{
    return inb (GPIO_PORT + GPIO1_DATA);
}

unsigned int 
_gpioa_set (unsigned int new)
{
    unsigned int old = inb (GPIO_PORT + GPIO1_DATA);
    outb (GPIO_PORT + GPIO1_DATA, new);
    return old;
}

unsigned int 
_gpioa_bic (unsigned int bits)
{
    unsigned int old =  inb (GPIO_PORT + GPIO1_DATA);
    outb (GPIO_PORT + GPIO1_DATA, old & ~bits);
    return old;
}


unsigned int 
_gpioa_bis (unsigned int bits)
{
    unsigned int old =  inb (GPIO_PORT + GPIO1_DATA);
    outb (GPIO_PORT + GPIO1_DATA, old | bits);
    return old;
}

void
_gpiob_dir (unsigned int outputs)
{
    outb (GPIO_PORT + GPIO2_DIR, outputs);
}

unsigned int 
_gpiob_get (void)
{
    return inb (GPIO_PORT + GPIO2_DATA);
}

unsigned int 
_gpiob_set (unsigned int new)
{
    unsigned int old = inb (GPIO_PORT + GPIO2_DATA);
    outb (GPIO_PORT + GPIO2_DATA, new);
    return old;
}


unsigned int 
_gpiob_bic (unsigned int bits)
{
    unsigned int old =  inb (GPIO_PORT + GPIO2_DATA);
    outb (GPIO_PORT + GPIO2_DATA, old & ~bits);
    return old;
}


unsigned int 
_gpiob_bis (unsigned int bits)
{
    unsigned int old =  inb (GPIO_PORT + GPIO2_DATA);
    outb (GPIO_PORT + GPIO2_DATA, old | bits);
    return old;
}
