/*
 * Copyright (c) 2000-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * p6032/hd2532.h: HD2532 alphanumeric display definitions
 */


#ifndef HD2532_STRIDE
#define HD2532_STRIDE		4
#endif
#ifndef HD2532_FLASH_OFFSET
#define HD2532_FLASH_OFFSET	0
#define HD2532_NFLASH_OFFSET	0x80
#endif

#define HD2532_FLASH(x)		(HD2532_FLASH_OFFSET+((x)*HD2532_STRIDE)
#define HD2532_UDCAR		(HD2532_NFLASH_OFFSET
#define HD2532_UDCRAM(x)	(HD2532_NFLASH_OFFSET+(0x08*HD2532_STRIDE)+((x)*HD2532_STRIDE))
#define HD2532_CW		(HD2532_NFLASH_OFFSET+(0x10*HD2532_STRIDE))
#define HD2532_CRAM		(HD2532_NFLASH_OFFSET+(0x18*HD2532_STRIDE))
#define HD2532_CHAR(x)		((x)*HD2532_STRIDE)

#define HD2532_CW_C	0x80	/* clear FLASH and CRAM */
#define HD2532_CW_S	0x40	/* start self test */
#define HD2532_CW_OK	0x20	/* self test passed */
#define HD2532_CW_BL	0x10	/* blink enable */
#define HD2532_CW_F	0x08	/* flash enable */
#define HD2532_CW_B(x)	((x)&7)	/* Brightness */
#define HD2532_CW_BMASK	0x07	/* Brightness 100% */
#define HD2532_CW_B100	0x00	/* Brightness 100% */
#define HD2532_CW_B80	0x01	/* Brightness 80% */
#define HD2532_CW_B53	0x02	/* Brightness 53% */
#define HD2532_CW_B40	0x03	/* Brightness 40% */
#define HD2532_CW_B27	0x04	/* Brightness 27% */
#define HD2532_CW_B20	0x05	/* Brightness 20% */
#define HD2532_CW_B13	0x06	/* Brightness 13% */
#define HD2532_CW_B0	0x07	/* Brightness 0% */
