/*
 * Copyright (c) 2000-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * p6032/ics9148.h: ICS9148 clock synthesiser for P-6032
 */


struct ics9148reg {
    unsigned char	freq;
    unsigned char	cpu;
    unsigned char	pci;
    unsigned char	sdraml;
    unsigned char	sdramh;
    unsigned char	periph;
    unsigned char	res;
};

#define ICS_I2C_BASE_ADDRESS	0xd2

#define ICS_FREQ_SPREAD_0_6	0x80	/* 0.6% spread spectrum */
#define ICS_FREQ_MASK		0x70
#define  ICS_FREQ_100_333_666	 0x70
#define  ICS_FREQ_95_318_635	 0x60
#define  ICS_FREQ_83_333_666	 0x50
#define  ICS_FREQ_75_300_600	 0x40
#define  ICS_FREQ_75_375_750	 0x30
#define  ICS_FREQ_69_343_685	 0x20
#define  ICS_FREQ_67_334_668	 0x10
#define  ICS_FREQ_60_300_600	 0x00
#define ICS_FREQ_USEREG		0x08
#define ICS_FREQ_SPREAD_DOWN	0x04
#define ICS_FREQ_SPREAD_ENABLE	0x02
#define ICS_FREQ_TRISTATE	0x01

#define ICS_CPU_SDRAM12		0x10
#define ICS_CPU_CPUCLK2		0x04
#define ICS_CPU_CPUCLK1		0x02
#define ICS_CPU_CPUCLK0		0x01

#define ICS_PCI_PCICLKF		0x40
#define ICS_PCI_PCICLK4		0x10
#define ICS_PCI_PCICLK3		0x08
#define ICS_PCI_PCICLK2		0x04
#define ICS_PCI_PCICLK1		0x02
#define ICS_PCI_PCICLK0		0x01

#define ICS_SDRAML_SDRAM7	0x80
#define ICS_SDRAML_SDRAM6	0x40
#define ICS_SDRAML_SDRAM5	0x20
#define ICS_SDRAML_SDRAM4	0x10
#define ICS_SDRAML_SDRAM3	0x08
#define ICS_SDRAML_SDRAM2	0x04
#define ICS_SDRAML_SDRAM1	0x02
#define ICS_SDRAML_SDRAM0	0x01

#define ICS_SDRAMH_AGP0		0x80
#define ICS_SDRAMH_SDRAM11	0x08
#define ICS_SDRAMH_SDRAM10	0x04
#define ICS_SDRAMH_SDRAM9	0x02
#define ICS_SDRAMH_SDRAM8	0x01

#define ICS_PERIPH_AGP1		0x10
#define ICS_PERIPH_AGP2		0x02
#define ICS_PERIPH_REF0		0x01

extern int	_sbd_icsread (void *, int);
extern int	_sbd_icswrite (const void *, int);
