#
# p6032/sbd.mk: Algorithmics P-6032 board
#
# Use -mips3 so as to support 64-bit exception handling and all
# 32 floating-point registers.
#

SBDDIRS		=../p6032
SBDFLAGS  	=-DINET
KITFLAGS	=-DALGPMON
CPU	  	=r4k
ISA		=-mips3
PCI		=yes
FPU		=yes
#CPUVARIANT	=??
CACHES		=r4k r5k r54 rm7k
WPOINTS		=r4k r5k rm7k
ENDIAN	  	=-EL

#DBGSIG		=sbddbg

NVENV		=sbdenv

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx \
		 sbd.c sbdtune.c \
		 sbdcache.c \
		 sbdnvram.c \
		 sbdflash.c sbdflashenv.c \
		 sbdbflash.c sbduflash.c sbdflash8.c sbdflash16.c \
		 pci_machdep.c \
		 sbddimm.c sbdpanel.c \
		 sbdfreq.c sbdics.c sbdsmb.c \
		 sbdapc.c sbdrtc.c sbdtod.c

SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

SBDOBJ		=sbdser.o sbdmisc.o sbd.o sbdtune.o \
		 sbdcache.o \
		 sbdnvram.o \
		 sbdflash.o sbdflashenv.o \
		 sbdbflash.o sbduflash.o sbdflash8.o sbdflash16.o \
		 pci_machdep.o \
		 sbddimm.o sbdpanel.o \
		 sbdfreq.o sbdics.o sbdsmb.o \
		 sbdapc.o sbdrtc.o sbdtod.o \
		 r4kclock.o

# MIPS RTPX support
RTPX		=yes
SBDRTPXCSRC	=sbdrtpx.c rtpx_ns16550.c
SBDRTPXSSRC	=

# AlgNET support (see sde/net/net.mk)
SBDNET  	=INET			# IPv4 only

# Onboard AMD PCInet/LANCE ethernet driver
SBDNETDRV	=if_le_pci.o am7990.o

## NatSemi DP83815 / SiS 900 / SiS 7016 ethernet driver
#SBDNETDRV	+=if_sis.o nsphyter.o mii.o mii_physubr.o
#SBDNET		+=P6032_DP83815

# Support the /dev/flash and /dev/panel interface
SBDFEATURES	=flashdev paneldev

MONITOR		=pmon

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80020000
DLBASE_U	=a0020000
