#ident "kit/pci/pci_skel: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * p4032/pci_skel.c: skeleton PCI device configuration
 */


#if #pci(yes)

#include <sys/types.h>
#include <mips/xcpt.h>
#include <mips/cpu.h>

#include <pci/pcivar.h>
#include <pci/pcireg.h>
#include <pci/pcidevs.h>
#include <pci/device.h>

#include "kit_impl.h"

static int skel_probe (struct device *parent, void *match, void *aux);
static void skel_attach (struct device * const parent,
			struct device * const self, void * const aux);

typedef struct skel_softc {
    struct device skel_dev;		/* base device */
    void *csr;
} skel_softc_t;


struct cfdriver skelcd = {
    0, "skel", skel_probe, skel_attach, DV_DULL, sizeof(skel_softc_t), 0, 0
};


static int
skel_probe (struct device *parent, void *match, void *aux)
{
    struct pci_attach_args *pa = (struct pci_attach_args *) aux;

#if 0
    if (PCI_VENDOR(pa->pa_id) != PCI_VENDOR_NAME)
	return 0;
    if (PCI_PRODUCT(pa->pa_id) != PCI_PRODUCT_NAME_DEVICE)
	return 0;
#endif

    return 1;
}

static void
skel_attach (struct device * const parent,
	     struct device * const self, void * const aux)
{
    skel_softc_t * const sc = (skel_softc_t *) self;
    struct pci_attach_args * const pa = (struct pci_attach_args *) aux;
    int unit = sc->skel_dev.dv_unit;
    vm_offset_t vap, pap;

    if (_pci_map_mem(pa->pa_tag, PCI_MAP_REG_START, &vap, &pap) != 0)
	return;

    sc->csr = (void *)vap;

}
#endif
