#ident "kit/pci/pcilookup.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 2001-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * pcilookup.c: lookup a PCI device id in pci_knowndevs table
 */


#ifdef IN_PMON
#include "mips.h"
#include "pmon.h"
#include "stdio.h"
#include "pcivar.h"
#include "pcireg.h"
#include "pcidevs.h"
#else
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <pci/pcivar.h>
#include <pci/pcireg.h>
#include <pci/pcidevs.h>
#endif

#include "pcidevs_data.h"

const struct pci_knowndev *
_pci_lookup (unsigned int vendor, unsigned int product)
{
    const struct pci_knowndev *kdp;

    kdp = pci_knowndevs;
    while (kdp->vendorname != NULL) {	/* all have vendor name */
	if (kdp->vendor == vendor
	    && (kdp->product == product
		|| (kdp->flags & PCI_KNOWNDEV_NOPROD) != 0))
	    break;
	kdp++;
    }
    return kdp;
}


/* feature loader */
void _pcilookup_load (void);
void _pcilookup_load () {}
