#ident "kit/pmon/pmonxcpt.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * pmonxcpt.c: LSI PMON exception handling hooks
 */


#include <stddef.h>
#include <mips/cpu.h>
#include <mips/xcpt.h>
#include "kit_impl.h"
#include "pmon.h"

static struct pmonhandler handlers[NXCPT];

void (*_pmon_xcptaddr)();


void
_xcpt_catch (unsigned int xcptno, int enable)
{
    struct pmonhandler *hand;
    
    if (xcptno >= NXCPT)
	return;

    hand = &handlers[xcptno];
    if (enable && !hand->enabled) {
	/* install our own handler */
	extern void _pmon_xcptlow();
	hand->addr = _pmon_xcptlow;
	pmon_onintr (xcptno, hand);
	if (!_pmon_xcptaddr)
	    /* remember PMON's own handler function */
	    _pmon_xcptaddr = hand->prev->addr;
    }
    else if (!enable && hand->enabled) {
	/* revert to PMON's own handler */
	hand->addr = _pmon_xcptaddr;
    }
    hand->enabled = enable;
}
