#ident "kit/r3kemon/r3keroot.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * r3keroot.c: a root for an emulated Posix-like file system under R3KEMU
 */


#define _KERNEL
#include <sys/types.h>
#include <sys/stat.h>
#include "file.h"

/* external file systems */
extern const struct fileops _mfs_ops;
extern const struct fileops _file_ops;

/* forward declarations */
static struct dirnode root_dir[];
static struct dirnode dev_dir[];

/* directories:	drwxr-xr-x */
#define DIRMODE	(S_IFDIR|S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH)

/* _root must be global, everything else is static */
struct dirnode _root = 
    DIRDESC(0,		0, DIRMODE, 0, _mfs_ops, root_dir);

static struct dirnode root_dir[] = {
    DIRDESC(".",	0, DIRMODE, 0, _mfs_ops, root_dir),
    DIRDESC("..",	0, DIRMODE, 0, _mfs_ops, root_dir),
    DIRDESC("dev",	0, DIRMODE, 0, _mfs_ops, dev_dir),
    DIRDESC("file",	0, DIRMODE, 0, _file_ops, 0),
    {0}
};

static struct dirnode dev_dir[] = {
    DIRDESC(".",	0, DIRMODE, 0, _mfs_ops, dev_dir),
    DIRDESC("..",	0, DIRMODE, 0, _mfs_ops, root_dir),
    {0}
};
