#
# sead2/sbd.mk: MIPS Technologies SEAD-2 board (generic)
# 
# Note that since the SEAD board is very soft, this code is
# pretty skeletal. It is based around the basic sys controller 
# supplied by MIPS, but you might have changed it!
#

SBDDIRS		=../sead2
SBDFLAGS  	=-DSEAD2

# Enable MIPS16 support in kit code
KITFLAGS	=-D__maybe_mips16

#SBDOPTIONS	=-DPIPECLK_HZ=40000000
#CPU	  	=??
#CPUVARIANT	=??
#ISA		=??
#FPU		=??
#ENDIAN	  	=??

SBDSRC		=sbdmisc.sx sbdfreq.c sbdfrom.c \
		 sbdfreq.c sbdser.sx
SBDOBJ		=sbdmisc.o sbdfreq.o sbdfrom.o \
		 sbdfreq.o sbdser.o flashrom.o r4kclock.o

# No board-reset support yet
#SBDLOW		=sbdreset.o sbdser.o sbdmisc.o

# Handle YAMON environment
NVENV		=sbdenv

# MIPS RTPX support
RTPX		=yes
SBDRTPXCSRC	=sbdrtpx.c rtpx_ns16550.c
SBDRTPXSSRC	=

# Have Flash support
SBDFEATURES	=flashdev

MONITOR		=yamon

# define lowest safe address for downloadable programs (cached & uncached)
DLBASE_C	=80100000
DLBASE_U	=a0100000

# Use MIPS flash download format for ROM builds
ROMDLFMT	=fl
