/*
 * Copyright (c) 2005 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * endian.c: endian conversion worker functions
 *
 * Only called when optimizing for size, and then functions in <mips/endian.h>
 * are not inlined.
 */

#ifdef __mips16
#undef __mips16
#endif

#ifdef __OPTIMIZE_SIZE__
#undef __OPTIMIZE_SIZE__
#endif

#include <sys/endian.h>

__attribute__ ((nomips16)) u_int16_t (__swap16md) (u_int16_t);
__attribute__ ((nomips16)) u_int32_t (__swap32md) (u_int32_t);

__attribute__ ((nomips16)) 
u_int16_t (__swap16md) (u_int16_t x)
{
#ifdef __swap16md
    return __swap16md(x);
#else
    return __swap16gen(x);
#endif
}

__attribute__ ((nomips16)) 
u_int32_t (__swap32md) (u_int32_t x)
{
#ifdef __swap32md
    return __swap32md(x);
#else
    return __swap32gen(x);
#endif
}
