.ident "kit/share/m32tlb.h: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 2006 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * m32tlb.h: MIPS32 TLB support functions for MIPS SDE
 */

	.set	nomips16

#if __mips != 32 && __mips != 64
#error use -mips32 or -mips64 option with this file
#endif

#define _BOOTCODE
#include <mips/asm.h>
#include <mips/regdef.h>
#include <mips/m32c0.h>

/*
 * Although this not an R4000 cpu, the TLB follows exactly the
 * R4000 architecture, so we use the same function names.
 * Note that pessimistic R4000 hazard timings are also used.
 *
 * XXX we could probably do with a switcher like cache.sx
 */

#if __mips64
#define rmfc0	dmfc0
#define rmtc0	dmtc0
#define sr	sd
#else
#define rmfc0	mfc0
#define rmtc0	mtc0
#define sr	sw
#endif

#if __mips_isa_rev >= 2
/* ssnop not needed with ehb explicit hazard barrier */
#define ssnop
#endif
