/*
 * Copyright (c) 2000-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * MIPS SDE kit YAMON interface definitions
 */


extern void yamon_print_count (unsigned int, const char *, unsigned int);

extern void yamon_print (unsigned int, const char *);

extern int yamon_getchar (unsigned int, char *);

extern void yamon_flush_cache (unsigned int);

#define YAMON_FLUSH_ICACHE	0
#define YAMON_FLUSH_DCACHE	1

/* Yamon handler type */
typedef void (*yamon_handler)(void);

/* Special exception ID for default handler */
#define YAMON_DEFAULT_EXC	0xfffffff0

/* Register exception handler */
extern int yamon_register_esr (
    unsigned int     id,	/* Exception ID */
    yamon_handler    func,	/* Handler func */
    void	   **handlep,	/* Deregistration handle */
    yamon_handler   *retfuncp	/* Return to YAMON func */
    );

/* Deregister exception handler */
extern int yamon_deregister_esr (
    void 	    *handle        /* Deregistration handle */
    );

/* Return YAMON version number */
extern int yamon_version (void);
