.ident "lib/c/arch/mips/di.S: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * di.S: 64-bit arithmetic for gcc
 * XXX no longer used, now in libgcc.a
 */

	
/*
	.globl	__adddi3
	.globl	__subdi3
	.globl	__muldi3
	.globl	__lshrdi3
	.globl	__lshldi3
	.globl	__ashrdi3
*/

#include <mips/regdef.h>
#include <mips/asm.h>

#if defined(__MIPSEB__)	

#define HiR	v0
#define LoR	v1
#define Hi0	a0
#define Lo0	a1
#define Hi1	a2
#define Lo1	a3

#elif defined(__MIPSEL__)

#define HiR	v1
#define LoR	v0
#define Hi0	a1
#define Lo0	a0
#define Hi1	a3
#define Lo1	a2

#endif

/* loony tune time the shift count is passed as a 64bit value
*/
#define aSHIFT	a3

/* v0:v1 = a0:a1 + a2:a3
*/
LEAF(__adddi3)
	addu	LoR,Lo0,Lo1
	sltu	HiR,LoR,Lo0
	addu	HiR,Hi0
	addu	HiR,Hi1
	j	ra
END(__adddi3)

/* v0:v1 = a0:a1 - a2:a3
*/
LEAF(__subdi3)
	sltu	t0,Lo0,Lo1
	subu	LoR,Lo0,Lo1
	subu	HiR,Hi0,Hi1
	subu	HiR,t0
	j	ra
END(__subdi3)

LEAF(__negdi2)
	sltu	t0,$0,Lo0
	subu	LoR,$0,Lo0
	subu	HiR,$0,Hi0
	subu	HiR,t0
	j	ra
END(__negdi2)

/* v0:v1 = a0:a1 * a2:a3
 *	 = a1*a3 + a0*a3<<32 + a1*a2<<32
*/
LEAF(__muldi3)
	multu	Lo0,Lo1
	mfhi	HiR
	mflo	LoR
	multu	Hi0,Lo1
	mflo	t0
	addu	HiR,t0
	multu	Lo0,Hi1
	mflo	t0
	addu	HiR,t0
	j	ra
END(__muldi3)

/*
 * logical shift left 64bits
 * v0,v1 = a0,a1 << aSHIFT
*/
LEAF(__lshldi3)
	and	aSHIFT,0x3f
	li	t0,32
	bge	aSHIFT,t0,4f
	/* 0 <= aSHIFT < 32 */
	sll	HiR,Hi0,aSHIFT
	sll	LoR,Lo0,aSHIFT
	beqz	aSHIFT,1f
	subu	aSHIFT,t0,aSHIFT	/* 0 < aSHIFT < 32 */
	srl	t0,Lo0,aSHIFT
	or	HiR,t0
1:
	j	ra

4:
	/* 32 <= shamt < 64 */
	subu	aSHIFT,32
	li	LoR,0
	sll	HiR,Lo0,aSHIFT
	j	ra
END(__lshldi3)
/*
 * logical shift right 64bits
 * v0:v1 = a0:a1 >> aSHIFT
*/
LEAF(__lshrdi3)
	and	aSHIFT,0x3f
	li	t0,32
	bge	aSHIFT,t0,4f
	/* 0 <= aSHIFT < 32 */
	srl	HiR,Hi0,aSHIFT
	srl	LoR,Lo0,aSHIFT
	beqz	aSHIFT,1f
	subu	aSHIFT,t0,aSHIFT	/* 0 < aSHIFT < 32 */
	sll	t0,Hi0,aSHIFT
	or	LoR,t0
1:
	j	ra

4:
	/* 32 <= shamt < 64 */
	subu	aSHIFT,32
	li	HiR,0
	srl	LoR,Hi0,aSHIFT
	j	ra
END(__lshrdi3)

/*
 * arithmetic shift right 64 bits
 * v0:v1 = a0:a1 >> aSHIFT
*/
LEAF(__ashrdi3)
	and	aSHIFT,0x3f
	li	t0,32
	bge	aSHIFT,t0,4f
	/* 0 <= aSHIFT < 32 */
	sra	HiR,Hi0,aSHIFT
	srl	LoR,Lo0,aSHIFT
	beqz	aSHIFT,1f
	subu	aSHIFT,t0,aSHIFT	
	/* 0 < aSHIFT < 32 */
	sll	t0,Hi0,aSHIFT
	or	LoR,t0
1:
	j	ra

4:
	/* 32 <= shamt < 64 */
	subu	aSHIFT,32
	sra	HiR,Hi0,31
	sra	LoR,Hi0,aSHIFT
	j	ra
END(__ashrdi3)




