#ident "lib/c/arch/mips/omemset.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * omemset.c: fast memset 
 * XXX no longer used, see memset.S
 */


#include <stddef.h>
#include <string.h>

/* faster memset for r3000 (this isnt C code really)
*/

void	*memset	(void *dst, int fill, size_t n)
{
    void *limit = dst+n;

    if(n >= 16) {
	void *wlimit;
	
	/* align dst to word boundary max 3 bytes
	 */
	while((unsigned)dst & 0x3)
	  *(unsigned char *)dst++ = fill;
	
	wlimit = (void *)((unsigned)limit & ~0x3);
	
	if(fill) {
	    /* replicate fill within word */
	    fill &= 0xff;
	    fill |= fill << 8;
	    fill |= fill << 16;
	}
	
	while(dst != wlimit) {
	    dst+=4;
	    *(unsigned *)(dst-4) = fill;
	}
    }
    
    while(dst != limit) {
	dst++;
	*(unsigned char *)(dst-1) = fill;
    }
    return limit-n;
}
