.ident "lib/c/arch/mips/saverest.S: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1997-2004 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * These functions implement the common function prologue and epilogue code.  
 * Note that they save the $s registers in the reverse order to that which
 * they would be saved by a normal prologue, but this should only be a 
 * problem for debuggers! 
 */

	
#include <mips/asm.h>
#include <mips/regdef.h>


LEAF(__savesi9)
	sw	s8,-36(t1)
XLEAF(__savesi8)
	sw	s7,-32(t1)
XLEAF(__savesi7)
	sw	s6,-28(t1)
XLEAF(__savesi6)
	sw	s5,-24(t1)
XLEAF(__savesi5)
	sw	s4,-20(t1)
XLEAF(__savesi4)
	sw	s3,-16(t1)
XLEAF(__savesi3)
	sw	s2,-12(t1)
XLEAF(__savesi2)
	sw	s1,-8(t1)
XLEAF(__savesi1)
	sw	s0,-4(t1)
	sw	t2,0(t1)	# t2 holds previous return address
	jr	ra
END(__savesi9)

	
LEAF(__restsi9)
	lw	s8,-36(t1)
XLEAF(__restsi8)
	lw	s7,-32(t1)
XLEAF(__restsi7)
	lw	s6,-28(t1)
XLEAF(__restsi6)
	lw	s5,-24(t1)
XLEAF(__restsi5)
	lw	s4,-20(t1)
XLEAF(__restsi4)
	lw	s3,-16(t1)
XLEAF(__restsi3)
	lw	s2,-12(t1)
XLEAF(__restsi2)
	lw	s1,-8(t1)
XLEAF(__restsi1)
	lw	t2,0(t1)
	lw	s0,-4(t1)
	.set	noreorder
	jr	ra
	move	ra,t2		
	.set	reorder
END(__restsi9)
	
	
#if __mips64
LEAF(__savedi9)
	sd	s8,-72(t1)
XLEAF(__savedi8)
	sd	s7,-64(t1)
XLEAF(__savedi7)
	sd	s6,-56(t1)
XLEAF(__savedi6)
	sd	s5,-48(t1)
XLEAF(__savedi5)
	sd	s4,-40(t1)
XLEAF(__savedi4)
	sd	s3,-32(t1)
XLEAF(__savedi3)
	sd	s2,-24(t1)
XLEAF(__savedi2)
	sd	s1,-16(t1)
XLEAF(__savedi1)
	sd	s0,-8(t1)
	sd	t2,0(t1)
	jr	ra
END(__savedi9)
	

LEAF(__restdi9)
	ld	s8,-72(t1)
XLEAF(__restdi8)
	ld	s7,-64(t1)
XLEAF(__restdi7)
	ld	s6,-56(t1)
XLEAF(__restdi6)
	ld	s5,-48(t1)
XLEAF(__restdi5)
	ld	s4,-40(t1)
XLEAF(__restdi4)
	ld	s3,-32(t1)
XLEAF(__restdi3)
	ld	s2,-24(t1)
XLEAF(__restdi2)
	ld	s1,-16(t1)
XLEAF(__restdi1)
	ld	t2,0(t1)
	ld	s0,-8(t1)
	.set	noreorder
	jr	ra
	move	ra,t2		
	.set	reorder
END(__restdi9)
#endif


#if (__mipsfp64 || __mips_fpr == 64) && !__SINGLE_FLOAT
/* save/restore even and odd 64-bit registers */
LEAF(__savedx12)
	s.d	$f31,-88(t1)
XLEAF(__savedx11)
	s.d	$f30,-80(t1)
XLEAF(__savedx10)
	s.d	$f29,-72(t1)
XLEAF(__savedx9)
	s.d	$f28,-64(t1)
XLEAF(__savedx8)
	s.d	$f27,-56(t1)
XLEAF(__savedx7)
	s.d	$f26,-48(t1)
XLEAF(__savedx6)
	s.d	$f25,-40(t1)
XLEAF(__savedx5)
	s.d	$f24,-32(t1)
XLEAF(__savedx4)
	s.d	$f23,-24(t1)
XLEAF(__savedx3)
	s.d	$f22,-16(t1)
XLEAF(__savedx2)
	s.d	$f21,-8(t1)
XLEAF(__savedx1)
	s.d	$f20,0(t1)
	jr	ra
END(__savedx12)
	

LEAF(__restdx12)
	l.d	$f31,-88(t1)
XLEAF(__restdx11)
	l.d	$f30,-80(t1)
XLEAF(__restdx10)
	l.d	$f29,-72(t1)
XLEAF(__restdx9)
	l.d	$f28,-64(t1)
XLEAF(__restdx8)
	l.d	$f27,-56(t1)
XLEAF(__restdx7)
	l.d	$f26,-48(t1)
XLEAF(__restdx6)
	l.d	$f25,-40(t1)
XLEAF(__restdx5)
	l.d	$f24,-32(t1)
XLEAF(__restdx4)
	l.d	$f23,-24(t1)
XLEAF(__restdx3)
	l.d	$f22,-16(t1)
XLEAF(__restdx2)
	l.d	$f21,-8(t1)
XLEAF(__restdx1)
	l.d	$f20,0(t1)
	jr	ra
END(__restdx12)
#endif
	
#if (__mipsfp64 || __mips_fpr == 64) && __SINGLE_FLOAT
/* save/restore even and odd 32-bit registers (r4640/4650 only) */
LEAF(__savesx12)
	s.s	$f31,-88(t1)
XLEAF(__savesx11)
	s.s	$f30,-80(t1)
XLEAF(__savesx10)
	s.s	$f29,-72(t1)
XLEAF(__savesx9)
	s.s	$f28,-64(t1)
XLEAF(__savesx8)
	s.s	$f27,-56(t1)
XLEAF(__savesx7)
	s.s	$f26,-48(t1)
XLEAF(__savesx6)
	s.s	$f25,-40(t1)
XLEAF(__savesx5)
	s.s	$f24,-32(t1)
XLEAF(__savesx4)
	s.s	$f23,-24(t1)
XLEAF(__savesx3)
	s.s	$f22,-16(t1)
XLEAF(__savesx2)
	s.s	$f21,-8(t1)
XLEAF(__savesx1)
	s.s	$f20,0(t1)
	jr	ra
END(__savesx12)
	

LEAF(__restsx12)
	l.d	$f31,-88(t1)
XLEAF(__restsx11)
	l.d	$f30,-80(t1)
XLEAF(__restsx10)
	l.d	$f29,-72(t1)
XLEAF(__restsx9)
	l.d	$f28,-64(t1)
XLEAF(__restsx8)
	l.d	$f27,-56(t1)
XLEAF(__restsx7)
	l.d	$f26,-48(t1)
XLEAF(__restsx6)
	l.d	$f25,-40(t1)
XLEAF(__restsx5)
	l.d	$f24,-32(t1)
XLEAF(__restsx4)
	l.d	$f23,-24(t1)
XLEAF(__restsx3)
	l.d	$f22,-16(t1)
XLEAF(__restsx2)
	l.d	$f21,-8(t1)
XLEAF(__restsx1)
	l.d	$f20,0(t1)
	jr	ra
END(__restsx12)
#endif	
	
/* save/restore even 64-bit registers */
LEAF(__savedp12)
	s.d	$f30,-40(t1)
XLEAF(__savedp10)
	s.d	$f28,-32(t1)
XLEAF(__savedp8)
	s.d	$f26,-24(t1)
XLEAF(__savedp6)
	s.d	$f24,-16(t1)
XLEAF(__savedp4)
	s.d	$f22,-8(t1)
XLEAF(__savedp2)
	s.d	$f20,0(t1)
	jr	ra
END(__savedp12)
	
	
LEAF(__restdp12)
	l.d	$f30,-40(t1)
XLEAF(__restdp10)
	l.d	$f28,-32(t1)
XLEAF(__restdp8)
	l.d	$f26,-24(t1)
XLEAF(__restdp6)
	l.d	$f24,-16(t1)
XLEAF(__restdp4)
	l.d	$f22,-8(t1)
XLEAF(__restdp2)
	l.d	$f20,0(t1)
	jr	ra
END(__restdp12)


#ifdef __SINGLE_FLOAT	
/* save/restore even 32-bit registers (r4640/4650 only) */
LEAF(__savesp6)
	s.s	$f30,-40(t1)
XLEAF(__savesp5)
	s.s	$f28,-32(t1)
XLEAF(__savesp4)
	s.s	$f26,-24(t1)
XLEAF(__savesp3)
	s.s	$f24,-16(t1)
XLEAF(__savesp2)
	s.s	$f22,-8(t1)
XLEAF(__savesp1)
	s.s	$f20,0(t1)
	jr	ra
END(__savesp6)
	
	
LEAF(__restsp6)
	l.s	$f30,-40(t1)
XLEAF(__restsp5)
	l.s	$f28,-32(t1)
XLEAF(__restsp4)
	l.s	$f26,-24(t1)
XLEAF(__restsp3)
	l.s	$f24,-16(t1)
XLEAF(__restsp2)
	l.s	$f22,-8(t1)
XLEAF(__restsp1)
	l.s	$f20,0(t1)
	jr	ra
END(__restsp6)
#endif
