.ident "lib/c/csu/crt0.S: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2004 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * crt0.S: C runtime startup code
 */

	
#include <mips/asm.h>
#include <mips/regdef.h>

#define ARGSIZE			(NARGSAVE*SZREG)
#define LOCALSIZE		0
#define FRAMESIZE(nsave)	((ARGSIZE + LOCALSIZE + ((nsave)*SZREG) + ALSZ) & ALMASK)
#define SAVEOFF(n)		(ARGSIZE + LOCALSIZE + ((n)*SZREG))

NESTED(_start, FRAMESIZE(1), ra)
	PTR_SUBU sp,FRAMESIZE(1)
	REG_S	ra,SAVEOFF(0)(sp)

	/* initialise our gp */
	la	gp,_gp
	
	/* save argc, argv, and environ */
	move	s0,a0
	move	s1,a1
	PTR_S	a2,environ

#ifdef MCRT0
	la	a0,_ftext
	la	a1,_ecode
	jal	_gmonstartup
#endif	

	/* call .init section to run constructors etc */
	jal	_init

	/* rv = main(argc, argv, environ) */
	move	a0,s0
	move	a1,s1
	PTR_L	a2,environ
	jal	main

	/* exit(rv) */
	move	a0,v0
	jal	exit

	/* just in case !! */
1:	break	1
	b	1b

	j	ra			# end of subroutine marker
END(_start)

	
/* 
 * Declare at end, so that assembler doesn't use gp to reference, so
 * we can use this object file for any -G size.
 */
	BSS(environ,SZPTR)

