#ident "lib/c/std/ctype.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * ./ctype.c : stdlib function
 */

#include <ctype.h>

#define _CT_CS	(_CT_C | _CT_S)		/* control character and white space */
#define _CT_UX	(_CT_U | _CT_X)		/* upper case hex digit */
#define _CT_LX	(_CT_L | _CT_X)		/* lower case hex digit */

const char _ctype[1+256] = {
	0,
	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,
	_CT_C,	_CT_CS,	_CT_CS,	_CT_CS,	_CT_CS,	_CT_CS,	_CT_C,	_CT_C,
	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,
	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,	_CT_C,
	_CT_SP,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,
	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,
	_CT_N,	_CT_N,	_CT_N,	_CT_N,	_CT_N,	_CT_N,	_CT_N,	_CT_N,
	_CT_N,	_CT_N,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,
	_CT_P,	_CT_UX,	_CT_UX,	_CT_UX,	_CT_UX,	_CT_UX,	_CT_UX,	_CT_U,
	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,
	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,	_CT_U,
	_CT_U,	_CT_U,	_CT_U,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_P,
	_CT_P,	_CT_LX,	_CT_LX,	_CT_LX,	_CT_LX,	_CT_LX,	_CT_LX,	_CT_L,
	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,
	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,	_CT_L,
	_CT_L,	_CT_L,	_CT_L,	_CT_P,	_CT_P,	_CT_P,	_CT_P,	_CT_C
};
