#ident "lib/c/stdio/_iobdata.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2006 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * _iobdata.c : standard I/O library
 */

/* --- _iobdata.c --- */
/* Data structures for stdio */

#include <stdio.h>
#include <stdlib.h>
#include "stdiolib.h"
#include "libc_private.h"

/*
 * The default console-only version of the stdui _io_funcs structure is
 * defined here, and references functions implementated in _iobfuncs.c.
 *
 * If the application makes calls to fopen() or fdopen() then this
 * definition will be overridden by the strong definition in
 * _iobproc.c.
 */

const struct _iobfuncs _io_funcs __attribute__((weak)) = {
    .filbuf = _filbuf_simple,
    .flsbuf = _flsbuf_simple,
    .fflush = _fflush_simple,
    .fwrite = _fwrite_simple,
    .fsync = _fsync_simple,
};


static struct _iov _iov0 = {
    NULL,
    {STDIN_INIT, STDOUT_INIT, STDERR_INIT, EMPTY_INIT}
};

static struct _atexit _atexit0;

static struct _libc_data _libc_data0 = {
    &_iov0.iob[0],	/* _stdin */
    &_iov0.iob[1],	/* _stdout */
    &_iov0.iob[2],	/* _stderr */
    &_iov0,		/* _iov */
    &_atexit0,		/* _atexit */
    1			/* opterr */
};

#if defined(__mips) && (__GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 7))
__attribute__ ((section (".sdata")))
#endif
struct _libc_data *_libc_data = &_libc_data0;
