#ident "lib/c/stdio/perror.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * perror.c : standard I/O library
 */


#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/uio.h>

void perror(const char *s)
{
    struct iovec iov[4];
    int iovcnt = 0;
    char buf[64];
    char *err;
    int len;

    err = strerror_r (errno, buf, sizeof buf);

    len = s ? strlen (s) : 0;
    if (len > 0) {
	iov[iovcnt].iov_base = (char *)s;
	iov[iovcnt++].iov_len = len;
	iov[iovcnt].iov_base = ": ";
	iov[iovcnt++].iov_len = 2;
    }
    iov[iovcnt].iov_base = err;
    iov[iovcnt++].iov_len = strlen (err);
    iov[iovcnt].iov_base = "\n";
    iov[iovcnt++].iov_len = 1;
    (void) writev (STDERR_FILENO, iov, iovcnt);
}
