#include <limits.h>

/* Nonzero if X is not aligned on a "long" boundary.  */
#define UNALIGNED(X) \
  ((long)X & (sizeof (long) - 1))

#define ALIGNED(X) (! UNALIGNED(X))

/* Nonzero if X and Y are not both aligned on a "long" boundary.  */
#define UNALIGNEDPAIR(X, Y) \
  (((long)X | (long)Y) & (sizeof (long) - 1))

#define ALIGNEDPAIR(X, Y) \
  (! UNALIGNEDPAIR(X, Y))

#if LONG_MAX == 2147483647L
#define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
#else
#if LONG_MAX == 9223372036854775807L
/* Nonzero if X (a long int) contains a NULL byte. */
#define DETECTNULL(X) (((X) - 0x0101010101010101) & ~(X) & 0x8080808080808080)
#else
#error long int is not a 32bit or 64bit type.
#endif
#endif

/* DETECTCHAR returns nonzero if (long)X contains the byte used 
   to fill (long)MASK. */
#define DETECTCHAR(X, MASK) (DETECTNULL(X ^ MASK))

#define TOO_SMALL(LEN) ((LEN) < sizeof (long))
