/*
 * Copyright (c) 1987 Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Arthur Olson.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#define  _POSIX_SOURCE
#include <time.h>
#include <libc_thread.h>

extern struct tm *_offtime_r(const clock_t *,long, struct tm *);

struct tm *gmtime_r (const time_t *clock, struct tm *tm)
{
    _offtime_r (clock, 0L, tm);
    tm->tm_zone = "GMT";	/* UCT ? */
    return tm;
}

struct tm *gmtime (const time_t *clock)
{
    static struct tm tm;
    _THREAD_PRIVATE_KEY(gmtime);
    struct tm *tmp = _THREAD_PRIVATE(gmtime, tm, NULL);
    if (tmp)
	return gmtime_r (clock, tmp);
    return NULL;
}
