ifeq ($(SDEPREFIX),)
SDEPREFIX=mips-sde-elf-
endif
AR	=$(SDEPREFIX)ar
CC	=$(SDEPREFIX)gcc
SDECC	=$(CC)

-include ../../kit/sdeversion

ifndef SDE_MAJOR
# Guess major SDE version based on compiler version
SDE_MAJOR := $(shell \
	if $(CC) -v 2>&1 | fgrep 'gcc version 4.' >/dev/null; then \
	  echo "7"; \
	elif $(CC) -v 2>&1 | fgrep 'gcc version 3.' >/dev/null; then \
	  echo "6"; \
	else \
	  echo "5"; \
	fi)
endif

# Export to sub-makes
export SDE_MAJOR

SKIPARCHS=none

#EXCEPT	=-fexceptions

# Default to optimisation for size
OPTIM	=-Os -fno-optimize-sibling-calls

# Don't generate gp-relative addresses
ifneq (,$(strip $(filter 5,$(SDE_MAJOR))))
GPOPT	=-mno-gpopt
else
GPOPT	=-G0
endif

ifdef RELEASEBUILD
DEBUG	=
else
DEBUG	=-g
endif

ASSERT	=-DNDEBUG
CFLAGS	=$(VAR) $(OPTIM) $(GPOPT) $(DEBUG) $(ASSERT) $(EXCEPT) -ffreestanding -nostdinc -I$(ROOT)/../../include -ffunction-sections -fdollars-in-identifiers
override CFLAGS += $(CSL_CFLAGS)
ASFLAGS	=$(CFLAGS)
ARCH	=mips

#DESTROOT=/usr/local/sde5xxx
#DESTDIR	=$(DESTROOT)/sde/lib
DESTDIR ?= $(ROOT)/../sdelib

# To enable multi-byte character support, uncomment the next line
#CFLAGS += -DMB_SUPPORT

# flags to pass to recursive makes
F		=ROOT=$(ROOT)
