#ident "lib/ieee/ieee754.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/* ieee754 floating point arithmetic
 * single and double precision
 *
 * BUGS
 * not much dp done
 * doesnt generate IEEE754_INEXACT
 *
 */
/*
 * Copyright (c) 1996-2004 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include <limits.h>
#include <assert.h>
#include "ieee754int.h"

/* the control status register */
#ifndef ieee754_csr
ieee754_csr_t	ieee754_csr;
#endif

#if ! IEEE754_NO_XCPT
uint32_t ieee754si_xcpt(uint32_t r,const char *op, ...)
{
    struct ieee754xctx ax;
    
    if(!TSTX())
      return r;
    ax.op = op;
    ax.rt = IEEE754_RT_SI;
    ax.rv.si = r;
    va_start(ax.ap,op);
    ieee754_xcpt(&ax);
    return ax.rv.si;
}

uint64_t ieee754di_xcpt(uint64_t r,const char *op, ...)
{
    struct ieee754xctx ax;
    
    if(!TSTX())
      return r;
    ax.op = op;
    ax.rt = IEEE754_RT_DI;
    ax.rv.di = r;
    va_start(ax.ap,op);
    ieee754_xcpt(&ax);
    return ax.rv.di;
}
#endif
