#ident "lib/ieee/ieee754m.c: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * floor, trunc, ceil
 */
/*
 * Copyright (c) 1996-2004 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include "ieee754dp.h"

ieee754dp ieee754dp_floor(ieee754dp x)
{
    ieee754dp i;
    
    if(ieee754dp_lt(ieee754dp_nmodf(x,&i),ieee754dp_zero(0)))
      return ieee754dp_sub(i,ieee754dp_one(0));
    else
      return i;
}

ieee754dp ieee754dp_ceil(ieee754dp x)
{
    ieee754dp i;

    if(ieee754dp_gt(ieee754dp_nmodf(x,&i),ieee754dp_zero(0)))
      return ieee754dp_add(i,ieee754dp_one(0));
    else
      return i;
}

ieee754dp ieee754dp_trunc(ieee754dp x)
{
    ieee754dp i;

    (void)ieee754dp_nmodf(x,&i);
    return i;
}
