all: libm.a

include		$(ROOT)/../defines.mk

_VPATH		:=.
include 	$(ROOT)/$(ARCH)/Makefile.inc
include 	$(ROOT)/common_source/Makefile.inc
include 	$(ROOT)/common/Makefile.inc
include 	$(ROOT)/ieee/Makefile.inc

vpath	%.c	$(_VPATH)
vpath	%.s	$(_VPATH)
vpath	%.sx	$(_VPATH)
vpath	%.S	$(_VPATH)
vpath	%.h	$(_VPATH)

CPPFLAGS	=-I$(ROOT)/common_source
CFLAGS		+=$(VAR)
ASFLAGS		+=$(VAR)

# Optimise math library for speed, not size
# But this library aliases all over the place, so switch off
# strict aliasing rules	
OPTIM		=-O2 -fno-strict-aliasing

libm.a: $(LIBOBJ)
	$(AR) rcs $@ $?

install: libm.a
	if [ -d $(DESTDIR)/$(SUBDIR) ]; then \
		rm -f $(DESTDIR)/$(SUBDIR)/libm.a; \
	else \
		mkdir -p $(DESTDIR)/$(SUBDIR); \
	fi
	cp -p libm.a $(DESTDIR)/$(SUBDIR)/libm.a

clean:
	rm -f libm.a *.o core*
