.ident "lib/math/mips/fsqrt.S: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 1996-2005 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * fsqrt.S: maths library
 */

	
#if !defined(__SOFT_FLOAT) && !defined(__SINGLE_FLOAT)

#include <mips/asm.h>
#include <mips/regdef.h>
#include <sys/errno.h>
#include "r3kc1.h"

#error	XXX needs some work XXX	

	.set	nomips16
	.extern	errno,4
	
#if  __mips >= 2
	
LEAF(fsqrt)
	sqrt.s	$f0,$f12
	c.eq.s	$f0,$f0
	bc1t	1f
	li	v0,EDOM
	sw	v0,errno
1:	j	ra
END(sqrt)
	
#else
	

	.text
#define x	$f12		/* x is input value */
#define z	$f0		/* z gets result */
#define y	$f2		/* y hold previous estimate */
#define fzero	$f6

#define mexp	t0
#define exp	t1
#define i	t2
#define j	t3
#define T1	t4
#define T2	t5

#ifdef TEST
#define fsqrt	newfsqrt
#endif

LEAF(fsqrt)
	li.s	fzero,0.0

	/*mx=px[n0]&mexp;  get exponent */
	mfc1	T1,x
	li	mexp,0x7f800000
	and	exp,T1,mexp

	/* x == INF or NAN? */
	bne	exp,mexp,..isnum

	/* yes, but which */
	and	exp,T1,~0xff800000	/* mask off sign & exponent */
	bnez	exp,..retx		/* !=0:  NaN - return x */
	bltz	T1,..nan		/* <0:  -INF - return Nan */

..retx:	
	mov.s	z,x
	j	ra
	
..nan:	
	div.s	z,fzero,fzero
	li	v0,EDOM
	sw	v0,errno
	j	ra

..isnum:
	/*if(x==0.0) return(x);  sqrt(+-0) = +-0 */
	c.eq.s	x,fzero
	bc1t	..retx

	/* if(x<0) return((x-x)/(x-x)); sqrt(negative) is invalid */
	c.lt.s	x,fzero
	bc1t	..nan
#undef fzero

1:	and	T1,exp,0x40000000
	beqz	T1,2f

	/* exp is positive: exp /= 2 */
	srl	exp,1
	and	exp,0xdf800000
	or	exp,0x40000000
	b	4f

	/* exp is negative */
2:	srl	i,exp,2
	li	j,0x20000000
	blez	i,3f
1:	sll	i,1
	srl	j,1
	bgtz	i,1b

	/* exp = ((exp >> 1) | j) & 0x3f800000
3:	srl	exp,1
	or	exp,j
	and	exp,0x3f800000

	/* construct estimate based on exponent / 2 */
4:	mfc1	T1,z
	and	T1,0x007fffff
	or	T1,exp
	mtc1	T1,z
	
..iter:	
	/* iterate until difference in mantissa <= 2 */
	/* y = f */
	move.s	y,z
	/* z = z / y + y */
	div.s	z,x,y			
	add	z,y
	/* divide z mantissa by two */
	mfc1	T1,z
	mfc1	T2,y
	subu	T1,0x00800000
	mtc1	T1,z
	/* calculate difference in y & z mantissa */
	subu	T1,T2,T1
	abs	T1,T1
	bgt	T1,2,..iter
	
	j	ra
	END(fsqrt)
	
#endif /* __mips < 2 */
	
#endif /* !__SOFT_FLOAT */
