#ifndef _THREAD_PRIVATE_H_
#define _THREAD_PRIVATE_H_

#include <pthread.h>
#include <libc_thread.h>	/* most of it is here now */

#define __THREAD_MUTEX_NAME(name)	__CONCAT(_libc_storage_mutex_,name)

/* Declare a module mutex. */
#define _THREAD_PRIVATE_MUTEX(name)					\
	static pthread_mutex_t __THREAD_MUTEX_NAME(name) = 		\
		PTHREAD_MUTEX_INITIALIZER			
		
/* Lock a module mutex against use by any other threads. */
#define _THREAD_PRIVATE_MUTEX_LOCK(name) 				\
	pthread_mutex_lock(&__THREAD_MUTEX_NAME(name))
		
/* Unlock a module mutex. */
#define _THREAD_PRIVATE_MUTEX_UNLOCK(name) 				\
	pthread_mutex_unlock(&__THREAD_MUTEX_NAME(name))

#endif /* _THREAD_PRIVATE_H_ */
