#ifndef _LOCAL_BUS_H_
#define _LOCAL_BUS_H_

#include <machine/pio.h>

#ifdef __STDC__
#define CAT(a,b)	a##b
#define CAT3(a,b,c)	a##b##c
#else
#define CAT(a,b)	a/**/b
#define CAT3(a,b,c)	a/**/b/**/c
#endif

/*
 * Bus access types.
 */
typedef u_int32_t bus_addr_t;
typedef u_int32_t bus_size_t;
typedef u_int32_t bus_space_handle_t;

#include <sys/endian.h>

#if BYTE_ORDER == LITTLE_ENDIAN

/* no byte-swapping required */
#define bus_swap_data(m,d)	(d)
#define bus_swap_addr(m,a)	(a)

#else

/* in big-endian mode must swap i/o data, but not address */
#define swap8(d)		(d)
#define bus_swap_data(m,d)	CAT(swap,m)(d)
#define bus_swap_addr(m,a)	(a)

#endif

#include <machine/busspace.h>

#endif /* _LOCAL_BUS_H_ */
