#ifndef _LOCAL_BUS_H_
#define _LOCAL_BUS_H_

#include <machine/pio.h>

#ifdef __STDC__
#define CAT(a,b)	a##b
#define CAT3(a,b,c)	a##b##c
#else
#define CAT(a,b)	a/**/b
#define CAT3(a,b,c)	a/**/b/**/c
#endif

/*
 * Bus access types.
 */
typedef u_int32_t bus_addr_t;
typedef u_int32_t bus_size_t;
typedef u_int32_t bus_space_handle_t;

#include <sys/endian.h>

#if BYTE_ORDER == LITTLE_ENDIAN

/* no byte-swapping required */
#define bus_swap_data(m,d)	(d)
#define bus_swap_addr(m,a)	(a)

#else

/* in big-endian mode don't swap i/o data, but do swap address bits */
/* XXX this is due to a Bonito byte-swepping bug, which requires
   that Bonito's byte-swapping must be switched off */
#define swap8(d)		(d)
#define _swapa8(a)		((a) ^ 3)
#define _swapa16(a)		((a) ^ 2)
#define _swapa32(a)		((a) ^ 0)
#define bus_swap_data(m,d)	(d)
#define bus_swap_addr(m,a)	CAT(_swapa,m)(a)
#endif

#include <machine/busspace.h>

#endif /* _LOCAL_BUS_H_ */
