/* 
 * Copyright (c) 2001 Algorithmics Ltd
 *
 * Basic glue functions to map BSD signal handling to AlgRTX.
 *
 * This program is NOT free software, it is supplied under the terms
 * of the AlgNET License Agreement, a copy of which is available at:
 *
 *  http://www.algor.co.uk/algor/info/algnet-license.pdf
 *
 * Any company which has obtained and signed a valid AlgNET license
 * may use and modify this software internally and use (without
 * restrictions) any derived binary.  You may not, however,
 * redistribute this in whole or in part as source code, nor may you
 * modify or remove any part of this copyright message.  
 */

#if _POSIX_C_SOURCE < 199309L
#undef _POSIX_C_SOURCE
#define _POSIX_C_SOURCE	199309L
#endif

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/signal.h>

struct proc *curproc;	/* always null */

extern int _rtpx_kill (pid_t, int, union sigval, int);

void
psignal(p, signum)
    	struct proc *p;
	int signum;
{	
    union sigval    sival;
    sival.sival_int = 0;
    /* XXX ignore proc pointer and send to current process!! */
    (void) _rtpx_kill (0, signum, sival, SI_KERNEL);
}

void
csignal(pgid, signum, uid, euid)
	pid_t pgid;
	int signum;
	uid_t uid, euid;
{	
    if (pgid > 0) {
	union sigval    sival;
	sival.sival_int = 0;
	(void) _rtpx_kill (-pgid, signum, sival, SI_KERNEL);
    }
}


void	
pgsignal (pgid, signum, checkctty)
    pid_t pgid;
    int signum;
    int checkctty;
{
    csignal(pgid, signum, 0, 0);
}

