/*
 * Create private namespace for kernel by renaming all global symbols
 * that are actually reference from another module.
 *
 * This works in conjunction with the linker --retain-symbols-file 
 * which should remove global symbols which are in fact only used 
 * within a single module.
 */

/* dev/pci/if_le_pci.c */
#define le_pci_ca		_kern_le_pci_ca
#define le_cd			_kern_le_cd
#define am7990_config		_kern_am7990_config
#define am7990_intr		_kern_am7990_intr
#define am7990_copytodesc_contig _kern_am7990_copytodesc_contig
#define am7990_copytobuf_contig	_kern_am7990_copytobuf_contig
#define am7990_copyfrombuf_contig _kern_am7990_copyfrombuf_contig
#define am7990_zerobuf_contig	_kern_am7990_zerobuf_contig

/* dev/pci/if_de.c */
#define de_ca			_kern_de_ca
#define de_cd			_kern_de_cd

/* dev/pci/pcivar.h */
#define pci_mapreg_type		_kern_pci_mapreg_type
#define pci_mapreg_info		_kern_pci_mapreg_info
#define pci_mapreg_map		_kern_pci_mapreg_map
#define pci_io_find		_kern_pci_io_find
#define pci_mem_find		_kern_pci_mem_find
#define pci_get_capability	_kern_pci_get_capability
#define pci_devinfo		_kern_pci_devinfo
#define set_pci_isa_bridge_callback _kern_set_pci_isa_bridge_callback
#define pci_lookup_quirkdata	_kern_pci_lookup_quirkdata
#define pci_ca			_kern_pci_ca
#define pci_cd			_kern_pci_cd
#define pci_bus_dma_tag		_kern_pci_bus_dma_tag

#define pcibr_ca		_kern_pcibr_ca
#define pcibr_cd		_kern_pcibr_cd

/* arch/algrtx/x/sbdbus.c */
#define mainbus_ca		_kern_mainbus_ca
#define mainbus_cd		_kern_mainbus_cd

/* dev/rndvar.h */
#define rndstats		_kern_rndstats
#define enqueue_randomness	_kern_enqueue_randomness
#define get_random_bytes	_kern_get_random_bytes
/* The arc4random interface is made public and used by res_random.c in
   the network "C" library! */
/*#define arc4random_addrandom	_kern_arc4random_addrandom*/
/*#define arc4random		_kern_arc4random*/
/*#define arc4random_8		_kern_arc4random_8*/

/* net/if.h */
#define ifnet		_kern_ifnet
#define ether_ifattach		_kern_ether_ifattach
#define ether_ifdetach		_kern_ether_ifdetach
#define ether_ioctl		_kern_ether_ioctl
#define ether_input		_kern_ether_input
#define ether_output		_kern_ether_output
#define ether_sprintf		_kern_ether_sprintf
/*#define if_index		_kern_if_index*/
/*#define ifindex2ifnet		_kern_ifindex2ifnet*/
#define if_attach		_kern_if_attach
#define if_attachtail		_kern_if_attachtail
#define if_attachhead		_kern_if_attachhead
#define if_detach		_kern_if_detach
#define if_down			_kern_if_down
#define if_qflush		_kern_if_qflush
#define if_slowtimo		_kern_if_slowtimo
#define if_up			_kern_if_up
#define ifinit			_kern_ifinit
#define ifioctl			_kern_ifioctl
#define ifpromisc		_kern_ifpromisc
#define ifunit			_kern_ifunit
#define ifa_ifwithaddr		_kern_ifa_ifwithaddr
#define ifa_ifwithaf		_kern_ifa_ifwithaf
#define ifa_ifwithdstaddr	_kern_ifa_ifwithdstaddr
#define ifa_ifwithnet		_kern_ifa_ifwithnet
#define ifa_ifwithroute		_kern_ifa_ifwithroute
#define ifaof_ifpforaddr	_kern_ifaof_ifpforaddr
#define ifafree			_kern_ifafree
#define link_rtrequest		_kern_link_rtrequest
#define loioctl			_kern_loioctl
#define loopattach		_kern_loopattach
#define looutput		_kern_looutput
#define lortrequest		_kern_lortrequest
#define loif			_kern_loif

/* net/if_media.h */
#define ifmedia_init		_kern_ifmedia_init
#define ifmedia_add		_kern_ifmedia_add
#define ifmedia_list		_kern_ifmedia_list
#define ifmedia_set		_kern_ifmedia_set
#define ifmedia_ioctl		_kern_ifmedia_ioctl
#define ifmedia_match		_kern_ifmedia_match
#define ifmedia_delete_instance	_kern_ifmedia_delete_instance
#define ifmedia_baudrate	_kern_ifmedia_baudrate

/* net/netisr.h */
#define netisr			_kern_netisr
#define arpintr			_kern_arpintr
#define ipintr			_kern_ipintr
#define ip6intr			_kern_ip6intr
#define atintr			_kern_atintr
#define nsintr			_kern_nsintr
#define clnlintr		_kern_clnlintr
#define natmintr		_kern_natmintr
#define pppintr			_kern_pppintr
#define ccittintr		_kern_ccittintr
#define bridgeintr		_kern_bridgeintr

/* net/radix.h */
#define rn_mkfreelist		_kern_rn_mkfreelist
#define rn_init			_kern_rn_init
#define rn_inithead		_kern_rn_inithead
#define rn_refines		_kern_rn_refines
#define rn_walktree		_kern_rn_walktree
#define rn_addmask		_kern_rn_addmask
#define rn_addroute		_kern_rn_addroute
#define rn_delete		_kern_rn_delete
#define rn_insert		_kern_rn_insert
#define rn_lookup		_kern_rn_lookup
#define rn_match		_kern_rn_match
#define rn_newpair		_kern_rn_newpair
#define rn_search		_kern_rn_search
#define rn_search_m		_kern_rn_search_m

/* net/raw_cb.h */
#define rawcb			_kern_rawcb
#define raw_attach		_kern_raw_attach
#define raw_ctlinput		_kern_raw_ctlinput
#define raw_detach		_kern_raw_detach
#define raw_disconnect		_kern_raw_disconnect
#define raw_init		_kern_raw_init
#define raw_input		_kern_raw_input
#define raw_usrreq		_kern_raw_usrreq

/* net/route.h */
#define route_cb		_kern_route_cb
#define rtstat			_kern_rtstat
#define rt_tables		_kern_rt_tables
#define route_init		_kern_route_init
#define route_output		_kern_route_output
#define route_usrreq		_kern_route_usrreq
#define rt_ifmsg		_kern_rt_ifmsg
#define rt_maskedcopy		_kern_rt_maskedcopy
#define rt_missmsg		_kern_rt_missmsg
#define rt_newaddrmsg		_kern_rt_newaddrmsg
#define rt_setgate		_kern_rt_setgate
#define rt_setmetrics		_kern_rt_setmetrics
#define rt_timer_add		_kern_rt_timer_add
#define rt_timer_init		_kern_rt_timer_init
#define rt_timer_queue_create	_kern_rt_timer_queue_create
#define rt_timer_queue_change	_kern_rt_timer_queue_change
#define rt_timer_queue_destroy	_kern_rt_timer_queue_destroy
#define rt_timer_remove_all	_kern_rt_timer_remove_all
#define rt_timer_timer		_kern_rt_timer_timer
#define rtable_init		_kern_rtable_init
#define rtalloc			_kern_rtalloc
#define rtalloc1		_kern_rtalloc1
#define rtalloc_noclone		_kern_rtalloc_noclone
#define rtalloc2		_kern_rtalloc2
#define rtfree			_kern_rtfree
#define rtinit			_kern_rtinit
#define rtioctl			_kern_rtioctl
#define rtredirect		_kern_rtredirect
#define rtrequest		_kern_rtrequest
#define ipv4_tunnelsetup	_kern_ipv4_tunnelsetup

/* net/icmp_var.h */
#define icmpstat		_kern_icmpstat

/* net/if_ether.h */
#define etherbroadcastaddr	_kern_etherbroadcastaddr
#define ether_addmulti		_kern_ether_addmulti
#define ether_delmulti		_kern_ether_delmulti
#define ether_ipmulticast_min	_kern_ether_ipmulticast_min
#define ether_ipmulticast_max	_kern_ether_ipmulticast_max
#define arpintrq		_kern_arpintrq
#define arpwhohas		_kern_arpwhohas
#define arpintr			_kern_arpintr
#define arpresolve		_kern_arpresolve
#define arp_ifinit		_kern_arp_ifinit
#define arp_rtrequest		_kern_arp_rtrequest
#define arpresolve		_kern_arpresolve
#define arpintr			_kern_arpintr
#define arpioctl		_kern_arpioctl
#define arp_ifinit		_kern_arp_ifinit
#define revarpinput		_kern_revarpinput
#define in_revarpinput		_kern_in_revarpinput
#define revarprequest		_kern_revarprequest
#define revarpwhoarewe		_kern_revarpwhoarewe
#define revarpwhoami		_kern_revarpwhoami
#define db_show_arptab		_kern_db_show_arptab

/* net/rtsock.c */
#define routedomain		_kern_routedomain

/* netinet/igmp.h */
#define rti_delete		_kern_rti_delete

/* netinet/igmp_var.h */
#define igmpstat		_kern_igmpstat
#define igmp_init		_kern_igmp_init
#define igmp_input		_kern_igmp_input
#define igmp_joingroup		_kern_igmp_joingroup
#define igmp_leavegroup		_kern_igmp_leavegroup
#define igmp_fasttimo		_kern_igmp_fasttimo
#define igmp_slowtimo		_kern_igmp_slowtimo

/* netinet/in.h */
#define in_broadcast		_kern_in_broadcast
#define in_canforward		_kern_in_canforward
#define in_cksum		_kern_in_cksum
#define in_localaddr		_kern_in_localaddr
#define in_socktrim		_kern_in_socktrim
#define inet_ntoa		_kern_inet_ntoa

/* netinet/in_pcb.h */
#define baddynamicports		_kern_baddynamicports
#define ipport_firstauto	_kern_ipport_firstauto
#define ipport_lastauto		_kern_ipport_lastauto
#define ipport_hifirstauto	_kern_ipport_hifirstauto
#define ipport_hilastauto	_kern_ipport_hilastauto
#define in_losing		_kern_in_losing
#define in_pcballoc		_kern_in_pcballoc
#define in_pcbbind		_kern_in_pcbbind
#define in_pcbconnect		_kern_in_pcbconnect
#define in_pcbdetach		_kern_in_pcbdetach
#define in_pcbdisconnect	_kern_in_pcbdisconnect
#define in_pcbhashlookup	_kern_in_pcbhashlookup
#ifdef INET6
#define in6_pcbhashlookup	_kern_in6_pcbhashlookup
#define in6_pcbbind		_kern_in6_pcbbind
#define in6_pcbconnect		_kern_in6_pcbconnect
#define in6_setsockaddr		_kern_in6_setsockaddr
#define in6_setpeeraddr		_kern_in6_setpeeraddr
#endif /* INET6 */
#define in_pcbinit		_kern_in_pcbinit
#define in_pcblookup		_kern_in_pcblookup
#define in_pcbnotify		_kern_in_pcbnotify
#define in_pcbnotifyall		_kern_in_pcbnotifyall
#define in_pcbrehash		_kern_in_pcbrehash
#define in_rtchange		_kern_in_rtchange
#define in_setpeeraddr		_kern_in_setpeeraddr
#define in_setsockaddr		_kern_in_setsockaddr
#define in_baddynamic		_kern_in_baddynamic
#define in_selectsrc		_kern_in_selectsrc
#define in_pcbrtentry		_kern_in_pcbrtentry
#define in6_pcbnotify		_kern_in6_pcbnotify
#define in6_selectsrc		_kern_in6_selectsrc
#define in6_selecthlim		_kern_in6_selecthlim
#define in6_pcbsetport		_kern_in6_pcbsetport
#define in6_embedscope		_kern_in6_embedscope
#define in6_recoverscope	_kern_in6_recoverscope

/* netinet/in_systm.h */
#define iptime			_kern_iptime

/* netinet/in_var.h */
#define in_ifaddr		_kern_in_ifaddr
#define ipintrq			_kern_ipintrq
#define inetctlerrmap		_kern_inetctlerrmap
#define in_socktrim		_kern_in_socktrim
#define in_ifinit		_kern_in_ifinit
#define in_addmulti		_kern_in_addmulti
#define in_delmulti		_kern_in_delmulti
#define in_ifscrub		_kern_in_ifscrub
#define in_control		_kern_in_control

/* netinet/ip_ecn.h */
#define ip_ecn_ingress		_kern_ip_ecn_ingress
#define ip_ecn_egress		_kern_ip_ecn_egress
#ifdef INET6
#define ip6_ecn_ingress		_kern_ip6_ecn_ingress
#define ip6_ecn_egress		_kern_ip6_ecn_egress
#endif

/* netinet/ip_icmp.h */
#define icmp_error		_kern_icmp_error
#define icmp_input		_kern_icmp_input
#define icmp_reflect		_kern_icmp_reflect
#define icmp_send		_kern_icmp_send
#define icmp_sysctl		_kern_icmp_sysctl
#define icmp_mtudisc		_kern_icmp_mtudisc

/* netinet/ip_ipip.h */
#define ipipstat		_kern_ipipstat
#define ipip_sysctl		_kern_ipip_sysctl

/* netinet/ip_ipsp.h */
#define encdebug		_kern_encdebug
#define ipsec_acl		_kern_ipsec_acl
#define ipsec_keep_invalid	_kern_ipsec_keep_invalid
#define ipsec_in_use		_kern_ipsec_in_use
#define ipsec_last_added	_kern_ipsec_last_added
#define ipsec_require_pfs	_kern_ipsec_require_pfs
#define ipsec_expire_acquire	_kern_ipsec_expire_acquire
#define ipsec_soft_allocations	_kern_ipsec_soft_allocations
#define ipsec_exp_allocations	_kern_ipsec_exp_allocations
#define ipsec_soft_bytes	_kern_ipsec_soft_bytes
#define ipsec_exp_bytes		_kern_ipsec_exp_bytes
#define ipsec_soft_timeout	_kern_ipsec_soft_timeout
#define ipsec_exp_timeout	_kern_ipsec_exp_timeout
#define ipsec_soft_first_use	_kern_ipsec_soft_first_use
#define ipsec_exp_first_use	_kern_ipsec_exp_first_use
#define ipsec_def_enc		_kern_ipsec_def_enc
#define ipsec_def_auth		_kern_ipsec_def_auth
#define enc_xform_des		_kern_enc_xform_des
#define enc_xform_3des		_kern_enc_xform_3des
#define enc_xform_blf		_kern_enc_xform_blf
#define enc_xform_cast5		_kern_enc_xform_cast5
#define enc_xform_skipjack	_kern_enc_xform_skipjack
#define auth_hash_hmac_md5_96	_kern_auth_hash_hmac_md5_96
#define auth_hash_hmac_sha1_96	_kern_auth_hash_hmac_sha1_96
#define auth_hash_hmac_ripemd_160_96 _kern_auth_hash_hmac_ripemd_160_96
#define expclusterlist		_kern_expclusterlist
#define explist			_kern_explist
#define ipsec_policy_head	_kern_ipsec_policy_head
#define ipsec_acquire_head	_kern_ipsec_acquire_head
#define xformsw			_kern_xformsw
#define xformswNXFORMSW		_kern_xformswNXFORMSW
#define inet_ntoa4		_kern_inet_ntoa4
#define ipsp_address		_kern_ipsp_address
#define tdb_add_inp		_kern_tdb_add_inp
#define reserve_spi		_kern_reserve_spi
#define gettdb			_kern_gettdb
#define gettdbbyaddr		_kern_gettdbbyaddr
#define gettdbbysrc		_kern_gettdbbysrc
#define puttdb			_kern_puttdb
#define tdb_delete		_kern_tdb_delete
#define tdb_init		_kern_tdb_init
#define tdb_expiration		_kern_tdb_expiration
#define tdb_walk		_kern_tdb_walk
#define handle_expirations	_kern_handle_expirations
#define ipe4_attach		_kern_ipe4_attach
#define ipe4_init		_kern_ipe4_init
#define ipe4_zeroize		_kern_ipe4_zeroize
#define ipip_output		_kern_ipip_output
#define ipe4_input		_kern_ipe4_input
#define ipip_input		_kern_ipip_input
#ifdef INET
#define ip4_input		_kern_ip4_input
#endif
#ifdef INET6
#define ip4_input6		_kern_ip4_input6
#endif
#define etherip_output		_kern_etherip_output
#define etherip_input		_kern_etherip_input
#define ah_attach		_kern_ah_attach
#define ah_init			_kern_ah_init
#define ah_zeroize		_kern_ah_zeroize
#define ah_output		_kern_ah_output
#define ah_output_cb		_kern_ah_output_cb
#define ah_input		_kern_ah_input
#define ah_input_cb		_kern_ah_input_cb
#define ah_sysctl		_kern_ah_sysctl
#define ah_massage_headers	_kern_ah_massage_headers
#ifdef INET
#define ah4_input		_kern_ah4_input
#define ah4_input_cb		_kern_ah4_input_cb
#endif /* INET */
#ifdef INET6
#define ah6_input		_kern_ah6_input
#define ah6_input_cb		_kern_ah6_input_cb
#endif /* INET6 */
#define esp_attach		_kern_esp_attach
#define esp_init		_kern_esp_init
#define esp_zeroize		_kern_esp_zeroize
#define esp_output		_kern_esp_output
#define esp_output_cb		_kern_esp_output_cb
#define esp_input		_kern_esp_input
#define esp_input_cb		_kern_esp_input_cb
#define esp_sysctl		_kern_esp_sysctl
#ifdef INET
#define esp4_input		_kern_esp4_input
#define esp4_input_cb		_kern_esp4_input_cb
#endif /* INET */
#ifdef INET6
#define esp6_input		_kern_esp6_input
#define esp6_input_cb		_kern_esp6_input_cb
#endif /* INET6 */
#define tcp_signature_tdb_attach  _kern_tcp_signature_tdb_attach
#define tcp_signature_tdb_init	  _kern_tcp_signature_tdb_init
#define tcp_signature_tdb_zeroize _kern_tcp_signature_tdb_zeroize
#define tcp_signature_tdb_input	  _kern_tcp_signature_tdb_input
#define tcp_signature_tdb_output  _kern_tcp_signature_tdb_output
#define m_pad			_kern_m_pad
#define checkreplaywindow32	_kern_checkreplaywindow32
#define ipseczeroes		_kern_ipseczeroes
#define ipsp_process_packet	_kern_ipsp_process_packet
#define ipsp_process_done	_kern_ipsp_process_done
#define ipsp_spd_lookup		_kern_ipsp_spd_lookup
#define ipsec_common_input_cb	_kern_ipsec_common_input_cb
#define ipsp_acquire_sa		_kern_ipsp_acquire_sa
#define ipsec_add_policy	_kern_ipsec_add_policy
#define ipsp_match_policy	_kern_ipsp_match_policy
#define ipsp_acquire_expirations _kern_ipsp_acquire_expirations
#define ipsec_delete_policy	_kern_ipsec_delete_policy
#define ipsec_get_acquire	_kern_ipsec_get_acquire

/* netinet/ip_var.h */
#define ipq			_kern_ipq
#define ipstat			_kern_ipstat
#define ip_defttl		_kern_ip_defttl
#define ip_mtudisc		_kern_ip_mtudisc
#define ip_mtudisc_timeout	_kern_ip_mtudisc_timeout
#define ip_mtudisc_timeout_q	_kern_ip_mtudisc_timeout_q
#define ip_ctloutput		_kern_ip_ctloutput
#define ip_dooptions		_kern_ip_dooptions
#define ip_drain		_kern_ip_drain
#define ip_flush		_kern_ip_flush
#define ip_forward		_kern_ip_forward
#define ip_freef		_kern_ip_freef
#define ip_freemoptions		_kern_ip_freemoptions
#define ip_getmoptions		_kern_ip_getmoptions
#define ip_init			_kern_ip_init
#define ip_mforward		_kern_ip_mforward
#define ip_optcopy		_kern_ip_optcopy
#define ip_output		_kern_ip_output
#define ip_pcbopts		_kern_ip_pcbopts
#define ip_reass		_kern_ip_reass
#define in_iawithaddr		_kern_in_iawithaddr
#define ip_rtaddr		_kern_ip_rtaddr
#define ip_randomid		_kern_ip_randomid
#define ip_setmoptions		_kern_ip_setmoptions
#define ip_slowtimo		_kern_ip_slowtimo
#define ip_srcroute		_kern_ip_srcroute
#define ip_stripoptions		_kern_ip_stripoptions
#define ip_sysctl		_kern_ip_sysctl
#define ipintr			_kern_ipintr
#define ipv4_input		_kern_ipv4_input
#define rip_ctloutput		_kern_rip_ctloutput
#define rip_init		_kern_rip_init
#define rip_input		_kern_rip_input
#define rip_output		_kern_rip_output
#define rip_usrreq		_kern_rip_usrreq
#define	inetdomain		_kern_inetdomain
#define	inetsw			_kern_inetsw
#define ip_protox		_kern_ip_protox
#define ipsec_auth_default_level	_kern_ipsec_auth_default_level
#define ipsec_esp_trans_default_level	_kern_ipsec_esp_trans_default_level
#define ipsec_esp_network_default_level	_kern_ipsec_esp_network_default_level

/* netinet/tcp_debug.h */
#define tcp_debug		_kern_tcp_debug
#define tcp_debx		_kern_tcp_debx

/* netinet/tcp_seq.h */
#define tcp_iss		_kern_tcp_iss

/* netinet/tcp_timer.h */
#define tcptv_keep_init		_kern_tcptv_keep_init
#define tcp_keepidle		_kern_tcp_keepidle
#define tcp_keepintvl		_kern_tcp_keepintvl
#define tcp_maxidle		_kern_tcp_maxidle
#define tcp_ttl			_kern_tcp_ttl
#define tcp_backoff		_kern_tcp_backoff

/* netinet/tcp_var.h */
#define tcpstat		_kern_tcpstat
#define tcbtable		_kern_tcbtable
#define tcp_now			_kern_tcp_now
#define tcp_do_rfc1323		_kern_tcp_do_rfc1323
#define tcp_mssdflt		_kern_tcp_mssdflt
#ifdef TCP_SACK
#define tcp_do_sack		_kern_tcp_do_sack
#endif
#define tcp_attach		_kern_tcp_attach
#define tcp_canceltimers	_kern_tcp_canceltimers
#define tcp_close		_kern_tcp_close
#if defined(INET6) && !defined(TCP6)
#define tcp6_ctlinput		_kern_tcp6_ctlinput
#endif
#define tcp_ctlinput		_kern_tcp_ctlinput
#define tcp_ctloutput		_kern_tcp_ctloutput
#define tcp_disconnect		_kern_tcp_disconnect
#define tcp_drop		_kern_tcp_drop
#define tcp_dooptions		_kern_tcp_dooptions
#define tcp_drain		_kern_tcp_drain
#define tcp_fasttimo		_kern_tcp_fasttimo
#define tcp_init		_kern_tcp_init
#if defined(INET6) && !defined(TCP6)
#define tcp6_input		_kern_tcp6_input
#endif
#define tcp_input		_kern_tcp_input
#define tcp_mss			_kern_tcp_mss
#define tcp_mss_update		_kern_tcp_mss_update
#define tcp_mtudisc		_kern_tcp_mtudisc
#define tcp_mtudisc_increase	_kern_tcp_mtudisc_increase
#define tcp_newtcpcb		_kern_tcp_newtcpcb
#define tcp_notify		_kern_tcp_notify
#define tcp_output		_kern_tcp_output
#define tcp_pulloutofband	_kern_tcp_pulloutofband
#define tcp_quench		_kern_tcp_quench
#define tcp_reass		_kern_tcp_reass
#define tcp_rscale		_kern_tcp_rscale
#define tcp_respond		_kern_tcp_respond
#define tcp_setpersist		_kern_tcp_setpersist
#define tcp_slowtimo		_kern_tcp_slowtimo
#define tcp_template		_kern_tcp_template
#define tcp_timers		_kern_tcp_timers
#define tcp_trace		_kern_tcp_trace
#define tcp_usrclosed		_kern_tcp_usrclosed
#define tcp_sysctl		_kern_tcp_sysctl
#if defined(INET6) && !defined(TCP6)
#define tcp6_usrreq		_kern_tcp6_usrreq
#endif
#define tcp_usrreq		_kern_tcp_usrreq
#define tcp_xmit_timer		_kern_tcp_xmit_timer
#define tcpdropoldhalfopen	_kern_tcpdropoldhalfopen
#ifdef TCP_SACK
#define tcp_sack_option		_kern_tcp_sack_option
#define tcp_update_sack_list	_kern_tcp_update_sack_list
#define tcp_del_sackholes	_kern_tcp_del_sackholes
#define tcp_clean_sackreport	_kern_tcp_clean_sackreport
#define tcp_sack_adjust		_kern_tcp_sack_adjust
#define tcp_sack_output		_kern_tcp_sack_output
#define tcp_sack_partialack	_kern_tcp_sack_partialack
#ifdef DEBUG
#define tcp_print_holes		_kern_tcp_print_holes
#endif
#define tcp_newreno		_kern_tcp_newreno
#define tcp_seq_subtract	_kern_tcp_seq_subtract
#endif /* TCP_SACK */
#ifdef TCP_SIGNATURE
#define tcp_signature_apply	_kern_tcp_signature_apply
#endif /* TCP_SIGNATURE */
#define tcp_saveti		_kern_tcp_saveti
#define tcp_saveti6		_kern_tcp_saveti6
#define tcp_rst_ppslim		_kern_tcp_rst_ppslim

/* netinet/udp_var.h */
#define udpstat			_kern_udpstat
#define udbtable		_kern_udbtable
#if defined(INET6) && !defined(TCP6)
#define udp6_ctlinput		_kern_udp6_ctlinput
#define udp6_input		_kern_udp6_input
#define udp6_usrreq		_kern_udp6_usrreq
#endif
#define udp_ctlinput		_kern_udp_ctlinput
#define udp_init		_kern_udp_init
#define udp_input		_kern_udp_input
#ifdef INET6
#define udp6_output		_kern_udp6_output
#endif
#define udp_output		_kern_udp_output
#define udp_sysctl		_kern_udp_sysctl
#define udp_usrreq		_kern_udp_usrreq

/* sys/conf.h */
#define randomattach		_kern_randomattach
#define ptyattach		_kern_ptyattach

/* sys/device.h */
#define cfdata			_kern_cfdata
#define cfroots			_kern_cfroots
#define pdevinit		_kern_pdevinit
#define alldevs			_kern_alldevs
#define allevents		_kern_allevents
#define autoconf_verbose	_kern_autoconf_verbose
#define config_init		_kern_config_init
#define config_found_sm		_kern_config_found_sm
#define config_rootfound	_kern_config_rootfound
#define config_rootsearch	_kern_config_rootsearch
#define config_search		_kern_config_search

/* sys/domain.h */
#define domains			_kern_domains
#define domaininit		_kern_domaininit
#define unixdomain		_kern_unixdomain

/* sys/kernel.h */
#define hostid			_kern_hostid
#define hostname		_kern_hostname
#define hostnamelen		_kern_hostnamelen
#define domainname		_kern_domainname
#define domainnamelen		_kern_domainnamelen
#define lbolt			_kern_lbolt

/* sys/malloc.h */
#define kmemstats		_kern_kmemstats
#define kmemusage		_kern_kmemusage
#define kmembase		_kern_kmembase
#define kmemlimit		_kern_kmemlimit
#define bucket			_kern_bucket
#define malloc			_kern_malloc
#define free			_kern_free

/* sys/mbuf.h */
#define mbstat			_kern_mbstat
#define mbutl			_kern_mbutl
#define mclrefcnt		_kern_mclrefcnt
#define nmbclusters		_kern_nmbclusters
#define mclfree			_kern_mclfree
#define MCFail			_kern_MCFail
#define MPFail			_kern_MPFail
#define max_linkhdr		_kern_max_linkhdr
#define max_protohdr		_kern_max_protohdr
#define max_hdr			_kern_max_hdr
#define max_datalen		_kern_max_datalen
#define mbtypes			_kern_mbtypes
#define needqueuedrain		_kern_needqueuedrain
#define mbinit			_kern_mbinit
#define m_copym2		_kern_m_copym2
#define m_copym			_kern_m_copym
#define m_free			_kern_m_free
#define m_get			_kern_m_get
#define m_getclr		_kern_m_getclr
#define m_gethdr		_kern_m_gethdr
#define m_prepend		_kern_m_prepend
#define m_pulldown		_kern_m_pulldown
#define m_pullup		_kern_m_pullup
#define m_pullup2		_kern_m_pullup2
#define m_retry			_kern_m_retry
#define m_retryhdr		_kern_m_retryhdr
#define m_split			_kern_m_split
#define m_inject		_kern_m_inject
#define m_getptr		_kern_m_getptr
#define m_adj			_kern_m_adj
#define m_clalloc		_kern_m_clalloc
#define m_copyback		_kern_m_copyback
#define m_freem			_kern_m_freem
#define m_reclaim		_kern_m_reclaim
#define m_copydata		_kern_m_copydata
#define m_cat			_kern_m_cat
#define m_devget		_kern_m_devget
#define m_zero			_kern_m_zero
#define m_apply			_kern_m_apply
#define mbtypes			_kern_mbtypes

/* sys/md5k.h */
#define MD5Init			_kern_MD5Init
#define MD5Update		_kern_MD5Update
#define MD5Final		_kern_MD5Final

/* sys/protosw.h */
#define pffindproto		_kern_pffindproto
#define pffindtype		_kern_pffindtype
#define pfctlinput		_kern_pfctlinput

/* sys/msgbuf.h */
#define msgbufp			_kern_msgbufp
#define initmsgbuf		_kern_initmsgbuf

/* sys/un.h */
#define unp_attach		_kern_unp_attach
#define unp_bind		_kern_unp_bind
#define unp_connect		_kern_unp_connect
#define unp_connect2		_kern_unp_connect2
#define unp_detach		_kern_unp_detach
#define unp_discard		_kern_unp_discard
#define unp_disconnect		_kern_unp_disconnect
#define unp_drop		_kern_unp_drop
#define unp_gc			_kern_unp_gc
#define unp_mark		_kern_unp_mark
#define unp_scan		_kern_unp_scan
#define unp_shutdown		_kern_unp_shutdown
#define unp_externalize		_kern_unp_externalize
#define unp_internalize		_kern_unp_internalize
#define unp_dispose		_kern_unp_dispose

/* sys/systm.h sys/proc.h */
#define kmeminit		_kern_kmeminit
#define sleep			_kern_sleep
#define tsleep			_kern_tsleep
#define unsleep			_kern_unsleep
#define wakeup			_kern_wakeup
#define csignal			_kern_csignal
#define gsignal			_kern_gsignal
#define psignal			_kern_psignal
#define pgsignal		_kern_pgsignal
#define curproc			_kern_curproc

#define panic		_kern_panic
#define printf		_kern_printf
#define vprintf		_kern_vprintf
#define vsprintf	_kern_vsprintf
#define sprintf		_kern_sprintf
#define vsnprintf	_kern_vsnprintf
#define snprintf	_kern_snprintf
#define uprintf		_kern_uprintf
#define ttyprintf	_kern_ttyprintf

#define securelevel	_kern_securelevel
#define panicstr	_kern_panicstr
#define version		_kern_version
#define copyright	_kern_copyright
#define cold		_kern_cold
#define safepri		_kern_safepri

#define seltrue		_kern_seltrue
#define hashinit	_kern_hashinit

#define tablefull	_kern_tablefull

#define copystr		_kern_copystr
#define copyinstr	_kern_copystr
#define copyoutstr	_kern_copystr

#define hzto		_kern_hzto
#define hztoabs		_kern_hztoabs
#define microtime	_kern_microtime
#define ratecheck	_kern_ratecheck
#define ppsratecheck	_kern_ppsratecheck
#define scheduler_start	_kern_scheduler_start

#define timeout		_kern_timeout
#define untimeout	_kern_untimeout
#define ntimeout	_kern_ntimeout

#define cpu_startup	_kern_cpu_startup

#define msgbufenabled	_kern_msgbufenabled
#define msgbufmapped	_kern_msgbufmapped

#define shutdownhook_establish		_kern_shutdownhook_establish
#define shutdownhook_disestablish	_kern_shutdownhook_disestablish
#define doshutdownhooks			_kern_doshutdownhooks
#define shutdownhook_list		_kern_shutdownhook_list
#define shutdownhooks_done		_kern_shutdownhooks_done

/* sys/socket.h */
#define pfctlinput		_kern_pfctlinput

/* sys/socketvar.h */
#define sb_max			_kern_sb_max
#define sonewconn1		_kern_sonewconn1
#define socketops		_kern_socketops
#define netio			_kern_netio
#define netcon			_kern_netcon
#define netcls			_kern_netcls
#define uipc_usrreq		_kern_uipc_usrreq
#define sbappend		_kern_sbappend
#define sbappendaddr		_kern_sbappendaddr
#define sbappendcontrol		_kern_sbappendcontrol
#define sbappendrecord		_kern_sbappendrecord
#define sbcheck			_kern_sbcheck
#define sbcompress		_kern_sbcompress
#define sbcreatecontrol		_kern_sbcreatecontrol
#define sbdrop			_kern_sbdrop
#define sbdroprecord		_kern_sbdroprecord
#define sbflush			_kern_sbflush
#define sbinsertoob		_kern_sbinsertoob
#define sbrelease		_kern_sbrelease
#define sbreserve		_kern_sbreserve
#define sbwait			_kern_sbwait
#define sb_lock			_kern_sb_lock
#define soabort			_kern_soabort
#define soaccept		_kern_soaccept
#define sobind			_kern_sobind
#define socantrcvmore		_kern_socantrcvmore
#define socantsendmore		_kern_socantsendmore
#define soclose			_kern_soclose
#define soconnect		_kern_soconnect
#define soconnect2		_kern_soconnect2
#define socreate		_kern_socreate
#define sodisconnect		_kern_sodisconnect
#define sofree			_kern_sofree
#define sogetopt		_kern_sogetopt
#define sohasoutofband		_kern_sohasoutofband
#define soisconnected		_kern_soisconnected
#define soisconnecting		_kern_soisconnecting
#define soisdisconnected	_kern_soisdisconnected
#define soisdisconnecting	_kern_soisdisconnecting
#define solisten		_kern_solisten
#define sonewconn1		_kern_sonewconn1
#define soqinsque		_kern_soqinsque
#define soqremque		_kern_soqremque
#define soreceive		_kern_soreceive
#define soreserve		_kern_soreserve
#define sorflush		_kern_sorflush
#define sosend			_kern_sosend
#define sosetopt		_kern_sosetopt
#define soshutdown		_kern_soshutdown
#define sowakeup		_kern_sowakeup
#define sockargs		_kern_sockargs
#define sendit			_kern_sendit
#define recvit			_kern_recvit

/* sys/sysctl.h */
#define sysctl_int		_kern_sysctl_int
#define sysctl_rdint		_kern_sysctl_rdint
#define sysctl_string		_kern_sysctl_string
#define sysctl_tstring		_kern_sysctl_tstring
#define sysctl__string		_kern_sysctl__string
#define sysctl_rdstring		_kern_sysctl_rdstring
#define sysctl_rdstruct		_kern_sysctl_rdstruct
#define sysctl_struct		_kern_sysctl_struct
#define sysctl_dumpentry	_kern_sysctl_dumpentry
#define sysctl_iflist		_kern_sysctl_iflist
#define sysctl_rtable		_kern_sysctl_rtable
#define sysctl_clockrate	_kern_sysctl_clockrate
#define sysctl_rdstring		_kern_sysctl_rdstring
#define sysctl_rdstruct		_kern_sysctl_rdstruct
#define sysctl_ntptime		_kern_sysctl_ntptime
#define net_sysctl		_kern_net_sysctl

/* sys/syslog.h */
#define logpri			_kern_logpri
#define log			_kern_log
#define addlog			_kern_addlog
#define logwakeup		_kern_logwakeup
#define logputchar		_kern_logputchar
#define log_open		_kern_log_open

/* sys/timeout.h */
#define timeout			_kern_timeout
#define timeout_set		_kern_timeout_set
#define timeout_add		_kern_timeout_add
#define timeout_del		_kern_timeout_del
#define timeout_init		_kern_timeout_init
#define timeouts		_kern_timeouts
#define ntimeout		_kern_ntimeout

/* vm/pmap.h */
#define vtophys			_kern_vtophys

/* vm/vm_kern.h */
#define kernel_map		_kern_kernel_map
#define kmem_map		_kern_kmem_map
#define mb_map			_kern_mb_map
 
/* vm/vm_extern.h */
#define kmem_alloc		_kern_kmem_alloc
#define kmem_free		_kern_kmem_free
#define kmem_init		_kern_kmem_init
#define kmem_malloc		_kern_kmem_malloc
#define kmem_suballoc		_kern_kmem_suballoc
#define kernacc			_kern_kernacc

