# Copyright (c) 1996-2007 MIPS Technologies, Inc.
# 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#      * Redistributions of source code must retain the above copyright
#        notice, this list of conditions and the following disclaimer.
#      * Redistributions in binary form must reproduce the above
#      copyright
#        notice, this list of conditions and the following disclaimer
#        in the documentation and/or other materials provided with
#        the distribution.
#      * Neither the name of MIPS Technologies Inc. nor the names of its
#        contributors may be used to endorse or promote products derived
#        from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

ifeq ($(RTPX),yes)

THREADFEATURES += pthread

_VPATH += :../../rtpx

INCDIRS += -I ../../rtpx

ALL += libth.a

RTPXSELECT = $(notdir $(wildcard ../../rtpx/rtpx_*select.c))

SRCS += rtpx_proc.c rtpx_sig.c rtpx_th.c rtpx_attr.c rtpx_log.c \
	rtpx_stats.c rtpx_mqueue.c rtpx_key.c rtpx_once.c \
	rtpx_sigwait.c rtpx_sem.c rtpx_rwlock.c rtpx_rwlattr.c \
	rtpx_spawn.c rtpx_time.c rtpx_timer.c rtpx_ptimer.c \
	rtpx_semopen.c rtpx_flock.c \
	rtpx_sysconf.c rtpx_sdetty.c \
	rtpx_mem.c rtpx_mips.c \
	$(RTPXSELECT) \
	$(SBDRTPXCSRC) \
	conc.c

RTPXSSRC=$(SBDRTPXSSRC)

RTPXSRC =$(RTPXCSRC) $(RTPXSSRC)

RTPXOBJ = $(filter %.o,$(SRCS:.c=.o) $(SRCS:.cc=.o) $(SRCS:.sx=.o) $(SRCS:.s=.o) $(SRCS:.S=.o))

.PHONY: rtpx
rtpx: libth.a

libth.a: $(RTPXOBJ)
	$(AR) $(ARFLAGS) $@ $?

LIB_TEST +=rtpx-test
rtpx-test:
	@$(MAKE) SBD=$(SBD) rtpxclean
	@$(MAKE) SBD=$(SBD) rtpx
	@touch $@

APP_TEST +=rtpxampl-test
rtpxampl-test:
	@$(MAKE) -C ../../rtpxampl/rwlock SBD=$(SBD) KITBUILT=y
	@touch $@

CLEAN += rtpxclean
.PHONY: rtpxclean
rtpxclean:
	rm -f libth.a $(RTPXOBJ)

endif
