#ident "sde/rtpxlite/rtpxliteasm.S: Copyright (c) MIPS Technologies, Inc. All rights reserved."

/*
 * Copyright (c) 2005-2006 MIPS Technologies, Inc.
 * 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 *      * Redistributions of source code must retain the above copyright
 *        notice, this list of conditions and the following disclaimer.
 *      * Redistributions in binary form must reproduce the above
 *      copyright
 *        notice, this list of conditions and the following disclaimer
 *        in the documentation and/or other materials provided with
 *        the distribution.
 *      * Neither the name of MIPS Technologies Inc. nor the names of its
 *        contributors may be used to endorse or promote products derived
 *        from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#if __mips == 32 && __mips_isa_rev >= 2 && ! __mips16

#include <mips/asm.h>
#include <mips/regdef.h>
#include <mips/cpu.h>
#include <mips/mt.h>

	.set	nomips16

/*
 * Per thread data structure, must match definition
 * of "struct rtpx_thread" in rtpxlite.c.
 */
	.struct 0
TH_STKTOP:	PTR	0
TH_START:	PTR	0
	.previous

LEAF(_pthread_mt_fork)
	la	a1,1f			# new thread starts this label
	fork	a0, a1, a0		# passing arg0 to child
	jr	ra			# return to parent

	/* We are now executing in the new thread context */

/* WARNING:
 * For a brief period we are operating on the same stack as our parent,
 * but the parent may continue running and push more data onto its stack.
 * So if we take an interrupt while in the new thread context there is a
 * window where the interrupt handler could push an exception stack frame
 * onto the wrong stack and corrupt the parent thread's stack.
 * So we MUST use an exception handler which switches to an exception level
 * stack frame, rather than reusing the current "user" stack.
 */

1:	mfc0	a1,C0_TCCONTEXT		# get our thread pointer
	PTR_L	sp,TH_STKTOP(a1)	# get initial stack top
	PTR_L	t9,TH_START(a1)		# get start func
	PTR_SUBU sp,NARGSAVE*SZARG	# arg save area
	la	gp,_gp			# load global pointer
	jr	t9			# start thread code
END(_pthread_mt_fork)

#endif
