#include <stdlib.h>
#include <stdio.h>
#include <sys/errno.h>
#include <sys/signal.h>
#include <mips/cpu.h>
#include <mips/cpu.h>
#include <p4000/cpu_board.h>

#include "conc.h"

void hello( Process *, int );

int main()
{
	Process *p;
	int i;

	printf("RTOS test program 1\n");

	/* force initial priority low */
	ProcToLow();

	/* initialise processes */
	for (i = 1; i <= 3; i++) {
	    p = ProcAlloc(hello,0,1,i);
	    ProcRunLow(p);
	}

	/* start tasks */
	printf("\n!!!!!!!!!!!!!!!!!!!!!!!!Started processes!!!!!!!!!!!!!!!!!!!!!\n");
	
	/* make sure display is visible */
	*(volatile unsigned long *) PA_TO_KVA1 (ALPHN_BLNK_) = RESET_ONE;

	hello(NULL, 0);

	exit(0);
}



void hello ( Process *p, int idx )
{
    volatile unsigned long *display;
    long lcount = 0;
    int n;

    display = (unsigned long *) PA_TO_KVA1 (ALPHN_CHAR (idx));
    while (1) {
	*display = "0123456789abcdef"[lcount & 0xf] << 24;
	++lcount;
	for (n = rand() % 10000; n != 0; n--)
	    rand();
	if (lcount % 1000 == 0) {
	    *display = 'Z' << 24;
#if 0
	    ProcWait (((unsigned)rand() % 10 + 1) * 5000 / 64);
#else
	    ProcWait (5000 / 64);
#endif
	}

    }
}

