#include <stdlib.h>
#include <stdio.h>
#include <sys/errno.h>
#include <sys/signal.h>
#include <mips/cpu.h>
#include <p4000/cpu_board.h>

#include "conc.h"

void hello( Process *, int );

int main()
{
	Process *p;
	int i;

	/* make sure display is visible */
	*(volatile unsigned long *) PA_TO_KVA1 (ALPHN_BLNK_) = RESET_ONE;

	/* force initial priority low */
	ProcToLow();

	/* initialise & start 3 tasks */
	for (i = 0; i <= 3; i++) {
	    p = ProcAlloc(hello,0,1,i);
	    if (i == 0)
		ProcRunHigh(p);
	    else
		ProcRunLow(p);
	}

	while (1)
	    ProcWait (10000000/64);

	exit(0);
}



void hello ( Process *p, int idx )
{
    volatile unsigned long *display;
    long lcount = 0;
    int n;

    display = (unsigned long *) PA_TO_KVA1 (ALPHN_CHAR (idx));
    while (1) {
	*display = "0123456789abcdef"[++lcount & 0xf] << 24;
	if (idx == 0) {
	    /* high priority: 1 sec delay */
	    ProcWait (10000/64);
	}
#if 0
	else {
	    /* low priority: yield to another task */
	    ProcReschedule();
	}
#endif
    }
}

