#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <conc.h>

#include <mips/cpu.h>
#include <p4000/cpu_board.h>

static Process *	task[4];
static volatile int	taskfinished[4];

static void hello (Process *, int);
	    
static int task0stack[4][(16*1024)/sizeof(int)];	    

int main()
{
    Process *p;
    int i;

    /* force initial priority low */
    ProcToLow();

    /* initialise & start 3 tasks */
    for (i = 0; i <= 3; i++) {
	task[i]= ProcAlloc(hello,0,1,i);
	taskfinished[i] = 0;
	ProcRunLow(task[i]);
    }

    while (!taskfinished[0])
	ProcReschedule();

    for (i = 0; i < 4; i++) {
	assert (taskfinished[0]);
	taskfinished[0] = 0;
#if 0
	task[0]= ProcAlloc(hello,0,1,0);
#elif 0
	ProcInit(task[0],hello,task0stack[i],sizeof(task0stack[0]),1,0);
#else
	/* just run again with old stack */
#endif
	ProcRunLow (task[0]);
 	ProcWaitMs(2000);	/* 2 secs */
    }

    exit(0);
}


static void bpt() {};

static void hello (Process *p, int taskno)
{
    static int task0iter = 0;
    volatile unsigned long *blank;
    volatile unsigned long *display;
    long lcount;

    if (taskno == 0 && ++task0iter == 3) {
	bpt();
    }
	
    printf ("task %d started\n", taskno);

    display = (unsigned long *) PA_TO_KVA1 (ALPHN_CHAR (taskno));
    blank = (unsigned long *) PA_TO_KVA1 (ALPHN_BLNK_);

    do {
	for (lcount = 0; lcount < 2000; lcount++) {
	    *display = "0123456789abcdef"[lcount & 0xf] << 24;
	    *blank = RESET_ONE;
	}
    } while (taskno > 0);

    printf ("task %d finished\n", taskno);
    taskfinished[taskno] = 1;
    ProcStop();
}

